/*
 * File: app/controller/Navbar.js
 *
 * This file was generated by Sencha Architect version 4.2.3.
 * http://www.sencha.com/products/architect/
 *
 * This file requires use of the Ext JS 4.2.x library, under independent license.
 * License of Sencha Architect does not include license for Ext JS 4.2.x. For more
 * details see http://www.sencha.com/license or contact license@sencha.com.
 *
 * This file will be auto-generated each and everytime you save your project.
 *
 * Do NOT hand edit this file.
 */

Ext.define('model_wiz.controller.Navbar', {
    extend: 'Ext.app.Controller',

    onNext_btnClick: function(button, e, eOpts) {
        this.triggerStep(this.getActiveView(), [], 'on_next');
    },

    onBack_btnClick: function(button, e, eOpts) {
        this.triggerStep(this.getActiveView(), [], 'on_back');
    },

    getCard: function(card, value) {
        return card === 'header' ? this.getCardHeader() : this.getCardContainer();
    },

    getCardContainer: function() {
        return this.cardContainer = this.cardContainer || Ext.getCmp("card_container");
    },

    getCardHeader: function() {
        return this.cardHeader = this.cardHeader || Ext.getCmp("card_header");
    },

    getActiveView: function() {
        return this.getCardContainer().layout.getActiveItem().xtype;
    },

    setActiveCards: function(cards) {
        var me = this;
        return Object.keys(cards)
            .map(function(key) {
                return me.getCard(key)
                    .layout
                    .setActiveItem(cards[key]);
            });
    },

    controllerSelectModel: function(args, ids, step) {
        if (ids === 'on_select_model' || ids === 'on_next') {
            ids = this.concatIds(ids, 'jump_to_step02', 'jump_to_step03');
        }

        return model_wiz.helpers.Stream.publish('model_select', args, ids, model_wiz.app.getController('steps.nav.ModelSelect'));
    },

    controllerHostSelect: function(args, ids, step) {
        return model_wiz.helpers.Stream.publish('host_select', args, ids, model_wiz.app.getController('steps.nav.HostSelect'));
    },

    controllerSetupParameters: function(args, ids) {
        if(ids === 'prev_step') {
            ids = this.concatIds(ids, 'back_to_host_select', 'back_to_model_select');
        }

        return model_wiz.helpers.Stream.publish('setup_parameters', args, ids, model_wiz.app.getController('steps.nav.SetupParameters'));
    },

    controllerOverview: function(args, ids) {
        return model_wiz.helpers.Stream.publish('overview', args, ids, model_wiz.app.getController('steps.nav.Overview'));
    },

    triggerStep: function(step, args, ids) {
        return (this.steps[step] || this.steps['default']).call(this, args, ids, step);
    },

    isComingFromDiscovery: function() {
        return parent && parent.hasOwnProperty('WIZZARD_CONFIG_PARAMS') && parent.WIZZARD_CONFIG_PARAMS.from === 'discovery';
    },

    concatIds: function(ids, fromStatusGrid, fromDiscovery) {
        return [ids].concat(this.isComingFromDiscovery() ? fromDiscovery : fromStatusGrid);
    },

    enableNext: function(status) {
        Ext.getCmp("next_btn").setDisabled(! status);
        return status;
    },

    enableBack: function(status) {
        Ext.getCmp("back_btn").setDisabled(! status);
        return status;
    },

    showNext: function(status) {
        var fn = status ? 'show' : 'hide';
        Ext.get('next_btn')[fn]();
        return status;
    },

    showBack: function(status) {
        var fn = status ? 'show' : 'hide';
        Ext.get('back_btn')[fn]();
        return status;
    },

    setNextBtnText: function(text) {
        Ext.getCmp('next_btn').setText(text);
    },

    enableLoadingMask: function(status) {
        var fn = status ? 'show' : 'hide';
        var me = model_wiz.app.getController('Navbar');
        me.loading_mask = me.loading_mask || new Ext.LoadMask({
            msg:Ext.locale.translate('Loading') + "...",
            target: Ext.getCmp('main')
        });

        me.loading_mask[fn]();

        return status;
    },

    init: function(application) {
                this.steps = {
                    'model_select': this.controllerSelectModel,
                    'host_select': this.controllerHostSelect,
                    'setup_parameters': this.controllerSetupParameters,
                    'overview': this.controllerOverview,
                    'step_01': this.controllerSelectModel,
                    'step_02': this.controllerHostSelect,
                    'step_03': this.controllerSetupParameters,
                    'step_04': this.controllerOverview,
                    'default': function(a,t,s) { console.log(s,'doesnt exist'); }
                };

        this.control({
            "#next_btn": {
                click: this.onNext_btnClick
            },
            "#back_btn": {
                click: this.onBack_btnClick
            }
        });
    }

});
