/*
 * File: app/controller/steps/card/Fields.js
 *
 * This file was generated by Sencha Architect version 4.2.3.
 * http://www.sencha.com/products/architect/
 *
 * This file requires use of the Ext JS 4.2.x library, under independent license.
 * License of Sencha Architect does not include license for Ext JS 4.2.x. For more
 * details see http://www.sencha.com/license or contact license@sencha.com.
 *
 * This file will be auto-generated each and everytime you save your project.
 *
 * Do NOT hand edit this file.
 */

Ext.define('model_wiz.controller.steps.card.Fields', {
    extend: 'Ext.app.Controller',

    createField: function(isGlobal, data, scopeName) {
        var field = Ext.create(model_wiz.view.fields[data.type]);
        var Stream = model_wiz.helpers.Stream;
        var me = model_wiz.app.getController('steps.card.Fields');
        var setupParameters = me.getController('steps.nav.SetupParameters');
        var T = model_wiz.helpers.Utils;

        field.setDescription(data.description[Ext.locale.lang]);
        field.setFieldLabel(data.label[Ext.locale.lang]);
        field.setFieldName(data.name);
        field.streams = null;

        if(data.dependency !== null) field.setFieldDisable();

        if (data.data.hasOwnProperty('action')) {
            var newComboStore = Ext.create(model_wiz.store.comboMultipleStore, { storeId: data.name + "Store", height: 80, maxHeight: 80, minHeight: 80, filterPickList: true });
            field.getFieldCombo().bindStore(newComboStore);
            field.streams = me.createStreams(data, field);
        }
        else if(data.data.hasOwnProperty('store') && data.data.store.length) {
            var newComboStore = Ext.create(model_wiz.store.comboMultipleStore, { storeId: data.name + "Store", height: 80, maxHeight: 80, minHeight: 80, filterPickList: true });
            field.getFieldCombo().bindStore(newComboStore);
            field.streams = me.createStreams(data, field);
            newComboStore.add(data.data.store);
        }

        if (data.hasOwnProperty('createHost') && data.createHost === true) {
            Stream.subscribe('fieldThatCreatesHost', me.findHostsMapped, data.name.toLowerCase())
            .then(me.selectMappedHosts);
        }

        if (T.isPropertyTrue('createService', data)) {
            if(data.data.hasOwnProperty('store') && data.data.store.length) {
                T.getStore('selected_hosts_store')
                .chain(T.compose(T.fromNullable, T.pluck(['data', 'items'])))
                .map(function(xs) {
                    return xs.reduce(function(acc, host) {
                        return T.compose(T.chain(T.fromNullable), T.chain(T.safePluck('createService')), T.getController) ('steps.card.support.Services')
                        .chain(function(f) { return f(data.data.store, scopeName, host); })
                        .fold(
                            function(e)   { return acc; },
                            function(svc) { return acc.concat(svc); }
                        );
                    }, []);
                })
                .map(T.addRecord('services_created_tmp'))
                .fold(console.error.bind(console.error, 'Error to create services in data store: '), T.identity);
            }

            Stream.subscribe('fieldThatCreatesServices', me.findServiceMapped, data.name.toLowerCase());

            // Inserting remove attribute to this service
            Ext.getStore('selected_hosts_store').each(function(curr) {
                curr.set('services', Object.keys(curr.get('services')).reduce(function(acc, key) {
                    return Object.keys(curr.get('services')[key].localparams)
                    .some(function(localKey) {
                        return curr.get('services')[key].localparams[localKey].name === data.name;
                    })
                    ? (acc[key] = Ext.apply(curr.get('services')[key], {remove: true}), acc)
                    : (acc[key] = curr.get('services')[key], acc);
                }, {}));
            });

        }


        if(data.hasOwnProperty('default') && data.default !== null && data.default !== undefined) {
            var getLocalParams = T.safePluck(['data', 'services', scopeName, 'localparams']);

            var setDefaultValue = T.compose(T.map(function(o) { return (o.value = data.default, o); }), T.fromNullable);

            Ext.getStore('selected_hosts_store').each(function(host) {
                T.fromNullable(host)
                .chain(getLocalParams)
                .chain(T.safePluck(data.name))
                .chain(setDefaultValue);
            });
        }

        if (data.hasOwnProperty('mandatory') && data.mandatory === true && field.setMandatory) field.setMandatory();

        field.globalField 	= isGlobal;
        field.localField 	= !isGlobal;
        field.inputType 	= data.type;
        field.data 			= data;

        return field;
    },

    createTab: function(disabled, modelGlobalparamsSize, data) {
        var me = this;

        if (! data.localparams.length) return null;

        var tab = Ext.create(model_wiz.view.model.step, { title: data.name });
        var description = Ext.create('widget.service_description');

        tab.setTabName(data.name);
        description.setFieldValue(data.description[Ext.locale.lang]);
        tab.setDisabled(disabled);

        var inputs = data.localparams.map(function(curr) {
            return me.createField(false, curr, data.name.toLowerCase());
        });

        tab.add([description].concat(inputs));

        return tab;
    },

    validateCard: function(input, event) {
        var support = model_wiz.helpers.Utils;
        var navbar = model_wiz.app.getController('Navbar');

        if (! Ext.getCmp('modelstepstabbar').getActiveTab()
                || Ext.getCmp('modelstepstabbar').getActiveTab().id !== input.up("modelstep").id) {
            return false;
        }

        return support.pluck('result', support.head(navbar.triggerStep('setup_parameters', [], 'validate_form')));
    },

    setField: function(input, event) {
        var me = this;
        var T = model_wiz.helpers.Utils;
        var isGlobal = this.isGlobal(input);
        var field = input.up('modelstep');

        me.getSelectedHosts().each(function(host) {
            if (isGlobal) {
                model_wiz.Functor.Right.of(T.curry(function(h,k) {
                    return T.safePluck(['data', 'globalparams', k], h);
                }))
                .ap(T.fromNullable(host))
                .ap(T.compose(T.chain(T.safePluck('name')), T.fromNullable) (input))
                .chain(T.identity)
                .chain(function(param) {
                    return (T.isPropertyFalse('createHost', param))
                        ? model_wiz.Functor.Right.of(param)
                        : model_wiz.Functor.Left.of(param);
                })
                .map(T.curry(function(p,f) {
                    return T.tryCatch(function() { return p['value'] = f(); });
                }))
                .ap(T.compose(T.map(T.bindContext(input)), T.chain(T.safePluck('getValue')), T.fromNullable) (input))
                .chain(T.identity);
            } else {
                var service_name = me.getTabName().toLowerCase();
                var field_name = input.up().up().getFieldName().toLowerCase();
                var service = host.data.services[service_name];

                var referServices = Object.keys(host.data.services_created).reduce(function(acc, key) {
                    return T.hasProperty('service_reference', host.data.services_created[key]) && (host.data.services_created[key].service_reference === service_name)
                        ? acc.concat(host.data.services_created[key])
                        : acc;
                }, []).concat(Ext.getStore('services_created_tmp').data.items.reduce(function(acc, rec) {
                        return T.hasProperty('service_reference', rec.data) && (rec.data.service_reference === service_name)
                            ? acc.concat(rec.data)
                            : acc;
                    }, []));

                service.localparams[field_name].value = input.getValue();
                host.data.services[service_name] = service;

                referServices.forEach(function(service) {
                    if (T.isPropertyEmpty('createService', service.localparams[field_name])) {
                        service.localparams[field_name].value = input.getValue();
                        if (T.hasProperty(service.name, host.data.services)) {
                            host.data.services[service.name] = service;
                        }
                    }
                });
            }
        });

        return input;
    },

    verifydependency: function(input) {
        var data 		= this.getData(this.isGlobal(input), input.getFieldName());
        var setupParam	= this.getController('steps.nav.SetupParameters');
        return data
            .reduce(function(acc, curr) {
                var isvalid = setupParam.isValidInputs2(curr.dependency);
                return isvalid ? acc.concat(curr) : acc;
            }, []);
    },

    requestdependency: function(field, dependencies) {
        var me 					= this;
        var head 				= model_wiz.helpers.Utils.head;
        var T 					= model_wiz.helpers.Utils;

        var selectedModels 		= Ext.getStore("selected_models_store");
        var selectedHosts 		= me.getSelectedHosts();

        var dependency 			= head(dependencies);
        var store 				= Ext.getStore(dependency.name.concat('Store'));
        var stackLoad 			= this.getController('steps.support.StackLoad');
        var hosts 				= selectedHosts.data.items.map(function(host) { return host.data; });

        if (! me[dependency.name + 'Timer']) {
            me.incTotalRequests();
        }

        clearTimeout(me[dependency.name.concat('Timer')]);
        me[dependency.name.concat('Timer')] = setTimeout(
            function request(accRecords, accErrors, accMapper, hosts) {
                if (hosts && hosts.length <= 0)
                    return stackLoad.isRunningAFlow()
                        ? me.storeResults(accRecords, accErrors, accMapper, store, dependency, field)
                        : me.handleResponse(me.storeResults(accRecords, accErrors, accMapper, store, dependency, field));

                store.load({
                    params: head(selectedModels
                                 .data.items
                                 .map(function(d) {
                                     return {
                                         model: 	d.get('name'),
                                         manager: 	d.get('manager'),
                                         method: 	dependency.data.action,
                                         param: 	Ext.JSON.encode(me.buildGlobalParams(head(hosts), dependency))
                                     };
                                 })),
                    callback : function(res, opts) {
                        var parsed = Ext.decode(opts.response.responseText);
                        var data = parsed.data || [];
                        var mapper = parsed.mapper || [];
                        me[dependency.name.concat('Timer')] = undefined;
                        me.updateProgressBar();
                        return ((parsed.hasOwnProperty('errors') && parsed.errors.length > 0) || data.length === 0)
                            ? request(
                                accRecords
                                , accErrors.concat({errors: parsed.errors, host: head(hosts), localparam: dependency.name})
                                , accMapper.concat(mapper)
                                , hosts.slice(1)
                              )
                            : request(
                                accRecords.concat(
                                    data.reduce(function(accParsed, curr) {
                                        return accRecords.some(function(a) {return a.value === curr.value;})
                                            ? accParsed
                                            : accParsed.concat(curr);
                                    }, [])
                                )
                                , accErrors
                                , accMapper.concat({
                                    data: mapper,
                                    host: head(hosts),
                                    service_ref: field.up().title.toLowerCase()
                                })
                                , hosts.slice(1)
                              );
                    }
                });
            },
            1000, [], [], [], hosts
        );
    },

    getSelectedHosts: function() {
        var T = model_wiz.helpers.Utils;

        return T.getStore('selected_hosts_store')
            .chain(function(store) {
                return T.compose(T.map(T.resultIn(store)), T.chain(T.fromEmpty), T.chain(T.safePluck(['data', 'items'])), T.fromNullable) (store);
            })
            .fold(
                function() { return Ext.getStore('original_hosts_selected'); },
                T.identity
            );
    },

    showProgressBar: function(index) {
        if (! this.isShowingProgressBar()) {
            Ext.MessageBox.show({
                title: Ext.locale.translate('Please wait'),
                msg: Ext.locale.translate('Loading items...'),
                progressText: Ext.locale.translate('Initializing'),
                width:300,
                progress:true,
                closable:false
            });
            this.progressBar = true;
            this.updateProgressBar();
        }
    },

    hideProgressBar: function() {
        Ext.MessageBox.hide();
        this.currentRequest = -1;
        this.lastTotalRequests = this.totalRequests;
        this.totalRequests = 0;
        return this.progressBar = false;
    },

    isShowingProgressBar: function() {
        return this.progressBar || false;
    },

    updateProgressBar: function() {
        this.currentRequest 	= (typeof this.currentRequest !== 'number' ? -1 : this.currentRequest) + 1;
        var total = this.getSelectedHosts().count() * this.totalRequests;
        var curr = (this.currentRequest * 100) / total;
        return Ext.MessageBox.updateProgress((curr / 100), Math.round(curr)+'% ' + Ext.locale.translate('Completed'));
    },

    incTotalRequests: function() {
        this.totalRequests = (this.totalRequests || 0) + 1;
    },

    handleResponse: function(results) {
        this.hideProgressBar();
        model_wiz.helpers.Stream.publish('fields', results, 'handleResponse', this);
        this.resetStoreResults();
    },

    storeRecords: function(results) {
        var me = this;
        var flatten = model_wiz.helpers.Utils.flatten;

        function store(records, errors, store, dependency, field) {
            var result = records.reduce(function(acc, curr) {
                acc[curr.value] = curr.key;
                return acc;
            }, {});

            store.removeAll();
            store.add(records);

            Ext.getStore('selected_hosts_store').each(function(host) {
                var tabName 		= field.up().getTabName().toLowerCase();
                var name 			= dependency.name.toLowerCase();
                var paramName 		= (tabName === 'global') ? name : tabName;
                var param = ['globalparams', 'services'].map(function(param) {
                       return Object.keys(host.data[param]).reduce(function(acc, key) {
                           return (acc === null && key === paramName)
                               ? host.data[param][key]
                               : acc;
                       }, null);
                    })
                    .filter(function(curr) { return curr !== null; })
                    [0];

                if (param.hasOwnProperty('data')) {
                    param.data.result = result;
                }
                else {
                    param.localparams[name].data.result = result;
                }
            });

            return errors;
        }

        return flatten(Object.keys(results || {}).map(function(key) {
            return store(results[key].accRecords, results[key].accErrors, results[key].store, results[key].dependency, results[key].field);
        }));
    },

    handleError: function(results, errData, store) {
        var T = model_wiz.helpers.Utils;

        return [].concat(
                T.flatten(Object.keys(results || {}).map(function(key) {
                        return results[key].accErrors;
                    }))
                    .reduce(function(acc, curr) {
                        acc.errors = (! acc.errors)
                            ? [Ext.locale.translate('Could not get any data from the selected hosts. Make sure your global settings are correct.')]
                            : acc.errors;

                        acc.hosts = acc.hosts
                            ? acc.hosts.concat(curr.host)
                            : [].concat(curr.host);

                        return acc;
                    }, {}));
    },

    findService: function(errors) {
        var find = model_wiz.helpers.Utils.find;
        var keys = model_wiz.helpers.Utils.keys;

        return errors.map(function(err) {
            return Ext.apply(err, {
                service: find(
                     function(serviceKey) {
                         var service = err.host.services[serviceKey];
                         return keys(service.localparams)
                                .some(function(localKey) {
                                    var localparam = service.localparams[localKey];
                                    return (localparam.name === err.localparam);
                                });
                     }
                    ,keys(err.host && err.host.services ? err.host.services : [])
                )
            });
        });
    },

    mountErrorsMsg: function(errors) {
        return {
            hasResult: (this.lastTotalRequests > errors.length),
            messages: errors.map(function(err) {
                var params = (err.hasOwnProperty('host')) ? Ext.apply(Ext.clone(err.host.globalparams), Ext.clone(err.host.services)) : {};
                var title =
                    (err.hasOwnProperty('host'))
                        ? ('<div>'.concat(Ext.locale.translate('API returned the following error on service %servicename% of host %hostname%')).concat('</div>'))
                            .replace('%servicename%', params[err.service].name)
                            .replace('%hostname%', err.host.host_name)
                        : '';

                var errors = '<code class="error-log">'.concat(Ext.locale.translate('Error')).concat(': ').concat((err.errors || []).map(function(e) {
                    return (e.length && e !== "")
                        ? e
                        : Ext.locale.translate('Could not get any data from the host. Make sure your global settings are correct.');
                })).concat('</code>');

                return '<div>'.concat(title).concat(errors).concat('</div>');
            })
        };
    },

    showPopupError: function(data) {
        var me = this;

        var total = me.getSelectedHosts().count() * this.lastTotalRequests;

        var firstMessage = (Ext.locale.translate('%qtd%/%of% data have been retrieved successfully'))
                                .replace('%qtd%', total - (data.hasResult ? data.messages.length : total))
                                .replace('%of%', total);

        var errorMessage = ('<div id="res_err_log">')
                                .concat(Array.isArray(data.messages) ? data.messages.join('<br>') : data.messages)
                                .concat('</div>');

        var optionsDefault = {
            title		: Ext.locale.translate('Discovery result'),
            width		: 500,
            icon		: Ext.MessageBox.INFO,
        };

        if (data.messages.length) {
            Ext.MessageBox.show(
                Ext.apply(
                    {
                        msg			: firstMessage,
                        buttons		: Ext.MessageBox.OKCANCEL,
                        buttonText	: {ok: Ext.locale.translate('Show errors'), cancel: 'Ok'},
                        fn			: function(btn) {
                            if (btn === 'ok') {
                                Ext.MessageBox.show(
                                    Ext.apply({msg: errorMessage, buttons: Ext.MessageBox.OK}, optionsDefault)
                                );
                            }
                        }
                    },
                    optionsDefault
                )
            );
        }

        return data.messages;
    },

    validateServicesTabs: function(results) {
        if (! this.isGlobal()) {
            return results;
        }

        var setupParams = model_wiz.app.getController('steps.nav.SetupParameters');
        var flatten = model_wiz.helpers.Utils.flatten;
        var services = flatten(Ext.getStore('selected_models_store').data.items.map(
                                function(curr) { return curr.data.services; }));

        // tabsTree :: Left (Object :: fail) | Right (Object :: success)
        var tabsTree = Object.keys(results).reduce(function(acc, key) {
                                                    var predicate = results[key].accRecords.length === 0;
                                                    var depth = predicate ? 'fail' : 'success';
                                                    acc[depth] = (acc[depth] || []).concat(results[key].dependency.name);
                                                    return acc;}, {});

        // tabs :: Left (Object :: tabs to fail) | Right (Object :: tabs to success)
        var tabs = Object.keys(tabsTree).reduce(function(acc, key) {
            acc[key] = tabsTree[key].map(function(inputName) {
                return services.filter(function(serviceModel) {
                                           return serviceModel.localparams.some(function(localparam) {
                                               return localparam.name === inputName;
                                           });
                                })
                                .map(function(serviceFiltered) { return serviceFiltered.name; });})
                                .reduce(function(acc, curr) { return acc.concat(curr); }, [])
                                .reduce(function(acc, name) {
                                        var tab = setupParams.findTab(name);
                                        return tab
                                            ? acc.concat(tab)
                                            : acc;
                                    }, []);
            return acc;
        }, {});

        // disable | enable :: tabs
        Object.keys(tabs).forEach(function(key) {
            var success 	= key === 'success';
            var icon 		= success ? '' : '/opmon/seagull/modules/opinterface/templates/themes/default/imgs/ico_alerta.png';
            var error 		= success ? '' : Ext.locale.translate('This service is not available for the selected host(s)');
            tabs[key].forEach(function(curr) {
                curr.setDisabled(! success);
                curr.setIcon(icon);
                curr.tab.setTooltip(error);
            });
        });

        return results;
    },

    getMapper: function(results) {
        var me 					= this;
        var T 					= model_wiz.helpers.Utils;
        var hostStore 			= Ext.getStore('hosts');
        var hostSelectedStore 	= Ext.getStore('selected_hosts_store');
        var serviceCreateTmp 	= Ext.getStore('services_created_tmp');

        var get 				= function(key) { return results[key].accMapper; };
        var getServices 		= T.compose(T.extClone, T.pluck(['data', 'services']), T.head, T.pluck(['data', 'items']));
        var mountService 		= function(data) { return T.compose(T.filterNotDuplicatedInStore('services_created_tmp', 'name'), me.mountMappedServices.bind(me, data)); };

        model_wiz.Functor.Right.of(T.compose(T.flatten, T.map(get)))
            .ap(T.compose(T.fromEmpty, Object.keys) (results))
            .chain(T.fromEmpty)
            .chain(function(dataMapped) {
                return T.compose(T.map(T.hasProperty('host_name')), T.chain(T.fromEmpty), T.map(T.head), T.safePluck('data'), T.head) (dataMapped)
                    .map(function(flag) {
                        return (flag === true)
                            ? T.compose(T.chain(T.addRecord('hosts')), T.chain(T.removeAllRecords('hosts')), me.mountMappedHosts.bind(me)) (dataMapped)
                                .leftMap(T.logError('Error to create hosts...'))

                            : T.compose(T.chain(T.addRecord('services_created_tmp')), mountService(dataMapped), getServices) (hostSelectedStore)
                                .leftMap(T.logError('Error to create services...'));
                    });
            });

        return results;
    },

    saveOriginalSelectedHost: function(data) {

        var T = model_wiz.helpers.Utils;

        var getItems = T.compose(T.chain(T.fromEmpty), T.safePluck(['data', 'items']));

        var pluckData = T.compose(T.listFold, T.map(T.safePluck('data')));

        T.getStore('selected_hosts_store')
            .chain(getItems)
            .map(pluckData)
            .chain(T.addRecord('original_hosts_selected'));

        return data;
    },

    mountMappedHosts: function(data) {
        var T = model_wiz.helpers.Utils;

        var me = this;

        function create(m) {
            var clone = T.compose(T.extClone, T.pluck('data'), T.head, T.pluck(['data', 'items'])) (me.getSelectedHosts());
            m.globalparams = Object.keys(m.globalparams).reduce(function(acc, key) {
                return (acc[key] = Ext.apply(clone.globalparams[key], { value: m.globalparams[key] }), acc);
            }, {});
            clone.host_id = null;
            return Ext.apply(clone, m);
        }

        function filterUniqueServices(services) {
            return model_wiz.Functor.Right.of(T.curry(function(xs,h) {
                return xs.filter(function(x) {
                    return x.host_reference === h;
                });
            }))
            .ap(T.fromNullable(services))
            .ap(T.compose(T.chain(T.safePluck('host_reference')), T.map(T.head), T.fromEmpty) (services));
        }

        function referServices(hosts) {
            return T.compose(T.map(T.map(T.pluck('data'))), T.chain(T.safePluck(['data', 'items'])), T.getStore) ('services_created_tmp')
                .chain(filterUniqueServices)
                .map(function(services) {
                    return hosts.reduce(function(acc, host) {
                        return T.compose(T.concat(acc), T.map(T.compose(T.apply({host_reference: host.host_name}), T.extClone))) (services);
                    }, []);
                })
                .chain(T.addRecord('services_created_tmp'))
                .fold(
                    function(e) {
                        console.log('Error to refer services: ', e);
                        return hosts;
                    },
                    function() { return hosts; }
                );
        }

        return data
            .reduce(function(acc, curr) {
                return T.fromNullable(curr)
                    .chain(T.safePluck('data'))
                    .map(T.map(create))
                    .map(referServices)
                    .chain(T.fromEmpty)
                    .chain(function(x) { return acc.map(T.concat(x)); });
            }, model_wiz.Functor.Right.of([]));
    },

    mountMappedServices: function(mappers, services) {
        var T = model_wiz.helpers.Utils;
        var me = this;

        var create = T.curry(function create(h, s, m) {
            return T.compose(T.map(T.extClone), T.safePluck(s)) (services)
                .map(function(service) {
                    var local = Object.keys(m.localparams).reduce(function(acc, key) {
                        return (acc[key.toLowerCase()] = Ext.apply(service.localparams[key.toLowerCase()], {value: m.localparams[key]}), acc);
                    }, {});
                    return Ext.apply(service, {localparams: Ext.apply(service.localparams, local), reference: m.reference, service_reference: s, host_reference: h.host_name, name: m.service_name});
                })
                .fold(
                    function(err) {
                        console.error('Error mount mapped services', err);
                        return null;
                    },
                    T.identity
                );
        });

        return mappers.map(function(curr) {
            return T.compose(T.map(create(curr.host, curr.service_ref)), T.map(T.extClone), T.pluck('data')) (curr);
        });
    },

    getData: function(isglobal, name) {
        var store = Ext.getStore('selected_models_store');
        var head = model_wiz.helpers.Utils.head; // Usando head somente pq hj usamos apenas um modelo
        var flatten = model_wiz.helpers.Utils.flatten;

        return head(
                store.data.items
                    .map(function(item) {
                        var localparams = flatten(item.data.services.map(function(service) { return service.localparams; }));
                        return localparams.concat(item.data.globalparams);
                    })
            )
            .filter(function(parameter) {
                return parameter.name === name;
            });
    },

    buildGlobalParams: function(host, dependency) {
        var allParams = Ext.apply(
            Ext.clone(host).globalparams,
            Object.keys(host.services).reduce(function(acc,key) {
                return Ext.apply(acc, host.services[key].localparams);
            }, {})
        );

        var params = Object.keys(allParams).reduce(function(acc, key) {
            return dependency.dependency.some(function(curr) { return curr === key; })
                ? (acc[key] = allParams[key], acc)
                : acc;
        }, {});

        return Object.keys(params)
                .reduce(function(acc, key) {
                    var curr = {};
                    curr[key] = params[key].value;
                    return Ext.apply(acc, curr);
                }, {});
    },

    ifmap: function(f, g, predicate) {
        var thiz = this;
        return function() {
            var a = Array.prototype.slice.call(arguments);
            return predicate.apply(thiz, a)
                ? f.apply(thiz, a)
                : g.apply(thiz, a);
        };
    },

    existAnyData: function(data) {
        return data.length ? true : false;
    },

    isGlobal: function() {
        return model_wiz.app.getController('steps.nav.SetupParameters').getActiveTab().tabName === 'global';
    },

    getTabName: function() {
        return model_wiz.app.getController('steps.nav.SetupParameters').getActiveTab().tabName;
    },

    createStreams: function(data, field) {
        var me = this;
        var navbar = this.getController('Navbar');

        var Stream = model_wiz.helpers.Stream;

        return (data.dependency || []).map(function(dependencyName) {
            return Stream.subscribe(me.ajustStreamTopic(dependencyName), me.cleanInput.bind(me, field.down('[name='+data.name+']')), data.name.toLowerCase())
                .then(me.verifydependency.bind(me, field))
                .then(me.ifmap(
                    function(dependencies) {
                        me.requestdependency(field, dependencies);
                        return dependencies;
                    },
                    function() { return []; },
                    me.existAnyData
                ))
                .then(function(field, dependencies) {
                    me.enableInput(dependencies.length > 0, field.getFieldCombo());
                }.bind(me, field));
        });
    },

    enableInput: function(status, input) {
        input.setDisabled(!status);
        return input;
    },

    cleanInput: function(inputDependency, inputChanged) {
        inputDependency.clearValue();
        return inputChanged;
    },

    storeResults: function(records, errors, mapper, store, dependency, field) {
        this.storeWS = this.storeWS || {};
        this.storeWS[store.storeId] = {
            accRecords: (this.storeWS.accRecords || []).concat(records),
            accErrors: (this.storeWS.accErrors || []).concat(errors),
            accMapper: (this.storeWS.accMapper || []).concat(mapper),
            store: store,
            dependency: dependency,
            field: field
        };
        return this.storeWS;
    },

    resetStoreResults: function() {
        this.storeWS = {};
    },

    ajustStreamTopic: function(str) {
        var compose = model_wiz.helpers.Utils.compose;
        var lower = model_wiz.helpers.Utils.lowercase;
        var concat = model_wiz.helpers.Utils.concat;

        return compose(concat('field_'), lower) (str);
    },

    findHostsMapped: function(input) {
        var T = model_wiz.helpers.Utils;
        var map = T.map;
        var val = input.getDisplayValue().split(', ');

        return (Array.isArray(val) ? val : [val]).reduce(function(acc, curr) {
            return T.compose(map(T.concat(acc)), map(T.pluck('data')), T.findRecord('hosts', 'host_name')) (curr)
                .fold(function(_) { return acc; }, T.identity);
        }, []);
    },

    findServiceMapped: function(input) {
        var T = model_wiz.helpers.Utils;

        var getInputVal = T.compose(T.split(', '), T.execWithContext(input), T.pluck('getDisplayValue'));
        var getServicesRelated = T.compose(T.listFold, T.listMap(T.map(T.pluck('data'))), T.map(T.filterRecord('services_created_tmp', 'reference')));
        var findHostByReference = T.compose(T.chain(T.findRecord('selected_hosts_store', 'host_name')), T.safePluck('host_reference'));

        function rejectDuplicated(service) {
            return findHostByReference(service)
                .chain(function(host) {
                    return Object.keys(host.get('services_created')).some(
                        function(key) {
                            return (host.get('services_created')[key].name === service.name);
                        }
                    )
                    ? model_wiz.Functor.Left.of([])
                    : model_wiz.Functor.Right.of(service);
                });
        }

        function setValue(service) {
            return model_wiz.Functor.Right.of(T.curry(
                function(svc, host) {
                    var fresh = {};
                    fresh[svc.name.toLowerCase()] = svc;
                    host.set('services_created', Ext.apply({}, host.get('services_created'), fresh));
                    return service;
                }
            ))
            .ap(T.fromNullable(service))
            .ap(findHostByReference(service));
        }

        return T.compose(T.listFold, T.map(T.chain(setValue)), T.map(rejectDuplicated), getServicesRelated, getInputVal) (input);
    },

    selectMappedHosts: function(hosts) {
        var store = Ext.getStore('selected_hosts_store');
        store.removeAll();
        store.add(hosts);
    },

    init: function(application) {
        var me 					= this;
        var Stream 				= model_wiz.helpers.Stream;
        var bind 				= model_wiz.helpers.Stream.bind;
        var trace 				= model_wiz.helpers.Stream.trace;

        Stream.subscribe('fields', this.setField, 'change');

        Stream.subscribe('fields', this.validateServicesTabs, 'handleResponse')
                .then(this.getMapper)
                .then(this.ifmap(
                    this.storeRecords,
                    this.handleError,
                    function(results) {
                        return Object.keys(results).some(function(key) {
                            return results[key].accRecords.length > 0;
                        });
                    }))
                .then(this.findService)
                .then(this.mountErrorsMsg)
                .then(this.showPopupError)
                .then(function() {
                    Stream.publish('setup_parameters', [], 'validate_form', model_wiz.app.getController('steps.nav.SetupParameters'));
                });

        Stream.subscribe('fields',
            this.ifmap(
                this.showProgressBar,
                function(x) { return x; },
                function(x) { return x !== false; }), 'progress_bar');
    }

});
