/*
 * File: app/controller/steps/nav/HostSelect.js
 *
 * This file was generated by Sencha Architect version 4.2.3.
 * http://www.sencha.com/products/architect/
 *
 * This file requires use of the Ext JS 4.2.x library, under independent license.
 * License of Sencha Architect does not include license for Ext JS 4.2.x. For more
 * details see http://www.sencha.com/license or contact license@sencha.com.
 *
 * This file will be auto-generated each and everytime you save your project.
 *
 * Do NOT hand edit this file.
 */

Ext.define('model_wiz.controller.steps.nav.HostSelect', {
    extend: 'Ext.app.Controller',

    onSelectionHostChange: function(selected) {
        var selected_hosts = Ext.getStore('selected_hosts_store');

        Ext.getCmp("host_selected_count_1").setValue(selected.length + " " + Ext.locale.translate('host(s) selected'));
        Ext.getCmp("host_selected_count").setValue(selected.length + " " + Ext.locale.translate('host(s) selected'));
        selected_hosts.removeAll();

        if (selected.length > 0) {
            selected_hosts.add(selected);
            return true;
        }
        return false;
    },

    createConfigView: function() {
        this.getController('Navbar').setActiveCards({
            "container": "step_03",
            "header": "step_03_header"
        });
        var selected_model = Ext.getStore('selected_models_store');
        var step_03_accordion = Ext.getCmp('step_03_accordion');
        var me = this;

        selected_model.each(function(model){
            var model_panel = Ext.create(model_wiz.view.model.panel, { title: ''+Ext.locale.translate('Model')+': ' + model.get('labelName') });

            var tabPanelId = model_panel.items.items[0].items.items[1].id;

            var modelGlobalparams = model.get("globalparams");
            var modelServices = model.get("services");
            var hostTags = model.get("tags");

            hostStore = Ext.getStore('selected_hosts_store');

            hostStore.each(function(host) {
                host.set('tags', hostTags.map(function(tag) { return tag.name; }));
                me.step03_build_data(host, modelGlobalparams, modelServices);
            });

            if (modelGlobalparams.length > 0) {
                me.step03_build_globalparams(model.get('description'), modelGlobalparams, tabPanelId);
            }

            me.step03_build_services(modelServices, tabPanelId, modelGlobalparams.length);

            step_03_accordion.add(model_panel);
        });
        step_03_accordion.doLayout();
    },

    step03_build_data: function(host, modelGlobalparams, modelServices) {
        var me = this;
        var cloneGlobalparams = model_wiz.helpers.Utils.reduce(modelGlobalparams, "name", true);
        host.data.globalparams = model_wiz.helpers.Utils.clone(cloneGlobalparams);

        var cloneServices = model_wiz.helpers.Utils.reduce(modelServices, "name", false);

        for (var svc in cloneServices) {
            cloneServices[svc].localparams = model_wiz.helpers.Utils.reduce(cloneServices[svc].localparams, "name", true);
            cloneServices[svc].globalparams = model_wiz.helpers.Utils.reduce(cloneServices[svc].globalparams, "name", false);
            cloneServices[svc].tags = cloneServices[svc].tags.map(function(tag) { return tag.name; });
        }
        host.data.services = model_wiz.helpers.Utils.clone(cloneServices);
    },

    step03_build_globalparams: function(description, modelGlobalparams, tabPanelId) {
        var modelStep = model_wiz.view.model.step;
        var globalStep = Ext.create(modelStep, { title: Ext.locale.translate('Global Settings') });
        var desc = Ext.create('widget.service_description');
        var field = model_wiz.app.getController('steps.card.Fields');

        globalStep.setTabName("global");
        desc.setFieldValue(description);
        globalStep.add(desc);

        var inputs = modelGlobalparams.map(
            model_wiz.helpers
                .Stream
                .bind(field.createField, true)
        );

        globalStep.add(inputs);
        Ext.getCmp(tabPanelId).add(globalStep);
    },

    step03_build_services: function(modelServices, tabPanelId, modelGlobalparamsSize) {
        var controller = model_wiz.app.getController('steps.card.Fields');
        var bind = model_wiz.helpers.Utils.bind;

        var tabs = modelServices.map(function(curr) {
            return controller.createTab(
                curr.localparams.some(function(local) {
                    return (local.hasOwnProperty('dependency')) && (local.dependency !== null) && (local.dependency.length > 0)
                        && local.dependency.every(function(currDep) {
                            return curr.localparams.some(function(currLocal) { return currLocal.name === currDep; }) === false;
                        });
                }),
                modelGlobalparamsSize,
                curr
            );
        });

        Ext.getCmp(tabPanelId).add(tabs);
        Ext.getCmp(tabPanelId).setActiveTab(0);
    },

    onBack: function() {
        this.getController('Navbar').setActiveCards({
            'container': 'step_01',
            'header': 'step_01_header'
        });
    },

    hasAnyHostSelected: function() {
        return Ext.getStore('selected_hosts_store').getCount() > 0;
    },

    clearGridFilterHosts: function() {
        Ext.getStore('hosts').clearFilter();
    },

    setHeaderTitleValue: function(value) {
        Ext.getCmp('step_02_header').items.items[0].setValue(value);
    },

    showViewAllBtn: function(status, btn) {
        var fn = status ? 'show' : 'hide';
        btn[fn]();
    },

    init: function(application) {
        var me					= this;
        var Stream 				= model_wiz.helpers.Stream;
        var bind 				= model_wiz.helpers.Stream.bind;
        var trace 				= model_wiz.helpers.Stream.trace;
        var Navbar 				= this.getController('Navbar');
        var SetupParameters		= this.getController('steps.nav.SetupParameters');

        Stream.subscribe('host_select', this.onSelectionHostChange, 'enable_next')
            .then(Navbar.enableNext);

        Stream.subscribe('host_select', this.createConfigView, 'on_next')
            .then(SetupParameters.getActiveTab)
            .then(SetupParameters.validateForm.bind(SetupParameters))
            .then(Navbar.enableNext)
            .then(this.getController('steps.card.Fields').saveOriginalSelectedHost);

        Stream.subscribe('host_select', this.onBack, 'on_back')
            .then(bind(Navbar.enableNext, false));

        Stream.subscribe('host_select', bind(this.showViewAllBtn, false), 'view_all_hosts')
            .then(bind(this.setHeaderTitleValue, Ext.locale.translate('Select one or more hosts to apply the model')))
            .then(this.clearGridFilterHosts);

        Stream.subscribe('host_select', bind(this.showViewAllBtn, true), 'show_btn_view_all_hosts')
            .then(function() {
                return me.setHeaderTitleValue(Ext.locale.translate('Recommended hosts for the model') + ' ' + Ext.getStore('selected_models_store').data.items[0].data.labelName);
            });
    }

});
