/*
 * File: app/controller/steps/nav/ModelSelect.js
 *
 * This file was generated by Sencha Architect version 4.2.3.
 * http://www.sencha.com/products/architect/
 *
 * This file requires use of the Ext JS 4.2.x library, under independent license.
 * License of Sencha Architect does not include license for Ext JS 4.2.x. For more
 * details see http://www.sencha.com/license or contact license@sencha.com.
 *
 * This file will be auto-generated each and everytime you save your project.
 *
 * Do NOT hand edit this file.
 */

Ext.define('model_wiz.controller.steps.nav.ModelSelect', {
    extend: 'Ext.app.Controller',

    onSelectTag: function(record) {
        var query_items = null;
        var loading_mask = new Ext.LoadMask({
            msg:Ext.locale.translate('Loading Models...'),
            target: Ext.getCmp('categories_view')
        });
        loading_mask.show();

        var all_models_store = Ext.getStore('all_models_store');
        var models_store = Ext.getStore('models_store');

        var icon = record.data.icon;
        var name = record.data.name;

        query_items = all_models_store.query('taglist', name, false, false, true);

        models_store.removeAll();
        models_store.add(query_items.items);

        Ext.get('cat_icon').show();
        Ext.getCmp('cat_icon').update('<div class="x-btn-default-small cat-icon-mini"><img src="/opmon/modelgroups/' + icon + '" /></div>');
        Ext.getCmp('cat_name').update('<h4>' + name + '</h4>');

        // Create services grid

        var models_content_dom = Ext.get('per_categories_content');
        var models_wrapper_array = Ext.query('*[id^=models_wrapper_]');
        for (var i=0; i < models_wrapper_array.length; i++) {
            Ext.get(models_wrapper_array[i]).hide();
        }

        var models_wrapper = Ext.get('models_wrapper_' + record.data.name);
        if (models_wrapper) {
            models_wrapper.show();
        } else {
            models_wrapper = Ext.create('Ext.container.Container', {
                renderTo: models_content_dom,
                id: 'models_wrapper_' + record.data.name,
                itemId: 'models_wrapper',
                flex: 1
            });

            models_wrapper_id = models_wrapper.getId();

            var models_wrapper_dom = Ext.get(models_wrapper_id);

            models_store.each(function(record){
                // Create the model box
                var model_box = Ext.create(model_wiz.view.model.box, {
                    id: model_box_id,
                    renderTo: models_wrapper_dom
                });
                var model_box_id = model_box.getId();

                // Get internal components
                var form_id = Ext.getCmp(model_box_id).items.keys[0];
                var services_length = Ext.getCmp(form_id).getComponent('model_innerwrapper').getComponent('services_length');
                var services_grid = Ext.getCmp(form_id).getComponent('services_grid');

                // Set the value for the internal components
                services_length.setValue(record.get('services').length);
                Ext.getCmp(form_id).loadRecord(record);

                //Create data store for the services grid
                Ext.create('Ext.data.Store', {
                    model: 'model_wiz.model.service_model',
                    storeId: model_box_id + '_store',
                    data : record.get("services")
                });

                // Create services grid
                Ext.create('Ext.grid.Panel', {
                    itemId: 'services_grid',
                    id: model_box_id + '_services_grid',
                    header: false,
                    store: model_box_id + '_store',
                    flex: 1,
                    columns: [
                        { text: Ext.locale.translate('Services'),  dataIndex: 'name', flex: 1 }
                    ],
                    width: 376,
                    height: 369,
                    disableSelection: true,
                    margin: '20 0 0 0',
                    renderTo: Ext.get(model_box_id)
                });

            });
        }

        loading_mask.destroy();

        var wrapper_height = Ext.get('categories_view_wrapper').getHeight() + 20;

        Ext.get('per_categories_content').show();
        Ext.get('categories_view_wrapper').hide();
        //Ext.get('categories_view_wrapper').setY(wrapper_height*(-1),true);
        //Ext.get('per_categories_content').setY(60,true);
        Ext.getCmp('category_boxes').setDisabled(true);
    },

    onSelectModel: function(button) {
        var parent_container = button.up('modelbox');
        var form = parent_container.child('form');
        var form_id = form.getForm().findField('id').getSubmitValue();

        var models = Ext.getStore('models_store');
        var model_record = models.findRecord('id', form_id, 0, false, false, true);

        var selected_model = Ext.getStore('selected_models_store');
        selected_model.removeAll();
        selected_model.add(model_record);
    },

    jumpToStep03: function() {
        if(Ext.getStore('hosts').isLoading()) {
            Ext.getStore('hosts').on('load', function() {
                Ext.getCmp("card_container").layout.setActiveItem("step_03");
                Ext.getCmp("card_header").layout.setActiveItem("step_03_header");
                model_wiz.app.getController('Navbar').triggerStep('host_select', [], 'on_next');
            });
        }
        else {
            Ext.getCmp("card_container").layout.setActiveItem("step_03");
            Ext.getCmp("card_header").layout.setActiveItem("step_03_header");
            Ext.getCmp('next_btn').setDisabled(true);
            model_wiz.app.getController('Navbar').triggerStep('host_select', [], 'on_next');
        }
        Ext.get('cat_icon').show();
    },

    jumpToStep02: function() {
        this.getController("Navbar").setActiveCards({
            "container": "step_02",
            "header": "step_02_header"
        });
        Ext.get('cat_icon').show();
    },

    openViewAllModels: function() {
        var wrapper_height = Ext.get('categories_view_wrapper').getHeight() + 20;
        var container_height = Ext.get('categories_view').getHeight();
        var navbar = this.getController('Navbar');

        Ext.get('full_list_content').show();
        Ext.get('categories_view_wrapper').hide();
        Ext.getCmp('header_btns').show();
        Ext.getCmp('category_boxes').setDisabled(true);
        Ext.get('full_list_content').setY(50);
        Ext.getCmp('full_list_content').setVisible(false).setVisible(true);
    },

    onViewAllSelectModel: function(record) {
        var selected_models = Ext.getStore('selected_models_store');
        selected_models.removeAll();

        if(record) {
            selected_models.add(record);

            Ext.getCmp('cat_icon').show();
            Ext.getCmp('cat_icon').update('<div class="x-btn-default-small cat-icon-mini"><img src="/opmon/modelgroups/' + selected_models.getAt(0).data.tags[0].icon + '" /></div>');
            Ext.getCmp('cat_name').update('<h4>' + selected_models.getAt(0).data.tags[0].name + '</h4>');

            return true;
        }
        return false;
    },

    hasAnySelected: function() {
        return Ext.getCmp('full_list').getSelectionModel().selected.items.length > 0;
    },

    backToFirstStep: function() {
        Ext.get('full_list_content').hide();
        Ext.get('cat_icon').hide();
        Ext.get('categories_view_wrapper').show();
        Ext.get('per_categories_content').hide();
        Ext.getCmp('category_boxes').setDisabled(false);
        Ext.get('categories_view_wrapper').setY(0);
        Ext.getCmp('categories_view_wrapper').setVisible(false).setVisible(true);
    },

    init: function(application) {
        var Stream 				= model_wiz.helpers.Stream;
        var bind 				= model_wiz.helpers.Stream.bind;
        var trace 				= model_wiz.helpers.Stream.trace;
        var Navbar 				= this.getController('Navbar');
        var selectedModelsStore = Ext.getStore('selected_models_store');

        Stream.subscribe('model_select', this.onSelectTag, 'on_select_tag')
            .then(bind(Navbar.enableNext, false))
            .then(bind(Navbar.enableBack, true));

        Stream.subscribe('model_select', this.onSelectModel, 'on_select_model')
            .then(this.getController('steps.nav.HostSelect').hasAnyHostSelected)
            .then(Navbar.enableNext);

        Stream.subscribe('model_select', this.onViewAllSelectModel, 'on_view_all_select_model')
            .then(Navbar.enableNext);

        Stream.subscribe('model_select', selectedModelsStore.getAllHosts.bind(selectedModelsStore, this.jumpToStep02.bind(this)), 'jump_to_step02')
            .then(bind(Navbar.showNext, true))
            .then(bind(Navbar.showBack, true))
            .then(this.getController('steps.nav.HostSelect').hasAnyHostSelected)
            .then(Navbar.enableNext);

        Stream.subscribe('model_select', selectedModelsStore.getAllHosts.bind(selectedModelsStore, this.jumpToStep03.bind(this)), 'jump_to_step03')
            .then(this.getController('steps.card.Fields').saveOriginalSelectedHost);

        Stream.subscribe('model_select', this.backToFirstStep, 'on_back')
            .then(bind(Navbar.enableNext, false))
            .then(bind(Navbar.enableBack, false));

        Stream.subscribe('model_select', this.openViewAllModels, 'view_all_models')
            .then(this.hasAnySelected)
            .then(Navbar.enableNext)
            .then(bind(Navbar.enableBack, true));
    }

});
