/*
 * File: app/controller/steps/nav/Overview.js
 *
 * This file was generated by Sencha Architect version 4.2.3.
 * http://www.sencha.com/products/architect/
 *
 * This file requires use of the Ext JS 4.2.x library, under independent license.
 * License of Sencha Architect does not include license for Ext JS 4.2.x. For more
 * details see http://www.sencha.com/license or contact license@sencha.com.
 *
 * This file will be auto-generated each and everytime you save your project.
 *
 * Do NOT hand edit this file.
 */

Ext.define('model_wiz.controller.steps.nav.Overview', {
    extend: 'Ext.app.Controller',

    active: function(p, result, req) {
        model_wiz.app.getController('Navbar').triggerStep('overview', [result, req], 'create_overview');
    },

    createOverview: function(result, req) {
        var overviewStore = Ext.getStore("overview_store");
        var treeStore = Ext.getStore("treeStore");

        if (result !== null && result !== undefined && result.length) {
            var data = result.map(function(curr) {
                return (function recursive(parent, child) {
                    parent.data = child.length > 0
                    ? child.reduce(function(acc, currChild) {
                        return (currChild.raw.node === "commands")
                        ? recursive(currChild.raw, currChild.childNodes)
                        : (Array.isArray(acc) ? acc : []).concat(recursive(currChild.raw, currChild.childNodes));
                    }, {})
                    : child;
                    return parent;
                })(curr.raw, curr.childNodes);
            });

            var services = data.reduce(function(acc, d) {
                return d.data
                ? acc.concat(d.data)
                : acc;
            }, []);

            var conflictCounts = services.filter(function(s) { return s.conflict === true; }).length;
            var servicesConflictCmp = Ext.ComponentQuery.query('#services_conflict')[0];
            var servicesCreated = services.length - conflictCounts;
            var servicesCreatedCmp = Ext.ComponentQuery.query('#services_created')[0];

            if(conflictCounts) {
                servicesConflictCmp.setTitle(conflictCounts + ' ' + Ext.locale.translate('Service(s) with conflict'));
                servicesConflictCmp.setVisible(true);
            }
            else {
                servicesConflictCmp.setVisible(false);
            }

            if(servicesCreated) {
                servicesCreatedCmp.setTitle((servicesCreated) + ' ' + Ext.locale.translate('New service(s) configured'));
                servicesCreatedCmp.setVisible(true);
            }
            else {
                servicesCreatedCmp.setVisible(false);
            }

            Ext.ComponentQuery.query('#services_conflict')[0].down('gridpanel').headerCt.items.getAt(0).hide();
            Ext.getStore('overview_services_store').add(services);
            overviewStore.add(data);
            Ext.getStore("license").add(Ext.decode(req.response.responseText).license);
        }
    },

    createData: function() {
        var head = model_wiz.helpers.Utils.head;
        var me = this;
        var data = this.getHostsWithoutConflict();
        var forms = {
            hostsModified: 	me.putEmptyArray(Ext.ComponentQuery.query('#hosts_modified form')[0].getValues()),
            hostsCreated: 	me.putEmptyArray(Ext.ComponentQuery.query('#hosts_created form')[0].getValues()),
            services: 		me.putEmptyArray(Ext.ComponentQuery.query('#services_created form')[0].getValues())
        };

        this.renameData(data); // Remove data and rename to approprieta key

        return data.map(function(d) {
            var clone = Ext.clone(d);
            var result = {
                address: 		clone.address,
                conflict: 		clone.conflict,
                description: 	clone.description,
                hostId: 		clone.hostId,
                opcfgSnmpCommunityId: 		clone.opcfgSnmpCommunityId,
                opcfgSnmpPort: 		clone.opcfgSnmpPort,
                hostName: 		clone.name,
                tags:			clone.tags,
                services: (clone.services || []).map(function(s) {
                    var clone = Ext.clone(s);
                    clone['serviceName'] = clone.name;
                    delete clone.name;
                    return Ext.apply(clone, forms.services);
                })
            };
            return Ext.apply(result, (me.hasId(clone) ? forms.hostsModified : forms.hostsCreated));
        });
    },

    insertIconPath: function(data) {
        var T = model_wiz.helpers.Utils;

        return T.getStore('selected_models_store')
            .chain(T.compose(T.map(T.head), T.safePluck(['data', 'items'])))
            .chain(T.getRecordFn('get'))
            .chain(function(f) { return T.tryCatch(function() { return f('tags'); }); })
            .chain(T.compose(T.chain(T.safePluck('icon')), T.map(T.head), T.fromEmpty))
            .map(T.concat('modelgroups/'))
            .map(function(i) { return {icon: i}; })
            .map(function(o) {
                return data.map(function(c) { return Ext.apply(c,o); });
            })
            .fold(
                function(e) {
                    console.error('Error to insert the icon:\n## ERROR MESSAGE ##\n', e);
                    return {data: data};
                },
                T.identity
            );
    },

    backToSetup: function() {
        var step_04_accordion = Ext.getCmp('step_04_accordion');

        this.getController('Navbar').setActiveCards({
            "container": "step_03",
            "header": "step_03_header"
        });
    },

    clearStores: function() {
        var services = Ext.getStore('overview_services_store');
        var hosts = Ext.getStore('overview_store');

        services.clearFilter();
        hosts.clearFilter();

        services.removeAll();
        hosts.removeAll();
    },

    putEmptyArray: function(values) {
        return [
                {key: 'contacts', 		value: []},
                {key: 'contactGroups', 	value: ['1']},
                {key: 'hostGroups',		value: []},
                {key: 'serviceGroups', 	value: []}
             ]
                    .reduce(function(acc, curr) {
                        return (acc[curr.key] = (acc[curr.key] === "") ? curr.value : acc[curr.key], acc);
                    }, values);
    },

    map: function(f, obj) {
        if (Array.isArray(obj)) {
            return obj.map(f);
        }
        return f(obj);
    },

    renameData: function(obj) {
        var association = {'hosts': 'services', 'services': 'command', 'commands': 'parameters'};
        var me = this;
        return (
            function recursion(data) {
                return me.map(function(root) {
                    if (root.hasOwnProperty('data')) {
                        var key = root.node;
                        root[association[key]] = Ext.clone(root.data);
                        delete root.data;
                        return recursion(root[association[key]]);
                    }
                    return root;
                }, data);
            }
        )(obj);
    },

    postData: function(f, d) {
        Ext.Ajax.timeout= 600000; // 10 minutes
        Ext.override(Ext.form.Basic, { timeout: Ext.Ajax.timeout / 1000 });
        Ext.override(Ext.data.proxy.Server, { timeout: Ext.Ajax.timeout });
        Ext.override(Ext.data.Connection, { timeout: Ext.Ajax.timeout });

        Ext.Ajax.request({
            url : '/opmon/seagull/www/index.php/models/action/finish_process/',
            method: 'POST',
            params: { data: Ext.JSON.encode(d) },
            success : f
        });
    },

    success: function(result) {
        return model_wiz.helpers.Stream.publish('overview', result, 'finish_process', this);
    },

    getHostsWithoutConflict: function() {
        var T = model_wiz.helpers.Utils;
        var serviceStore = Ext.getStore('overview_services_store');

        return Ext.getStore('overview_store').data.items
                .map(function(d) {
                    return d.data; })
                .filter(function(curr) {
                    return curr.isSelected; })
                .map(function(d) {
                    var servicesWithoutConflict = (d.data || []).filter(function(service) {
                        return T.findRecord('overview_services_store', 'name', service.name)
                            .chain(function(store) {
                                return T.compose(T.chain(T.glueContext(store)), T.safePluck('get')) (store);
                            })
                            .chain(function(f) {
                                return T.tryCatch(function() { return f('isSelected'); });
                            })
                            .fold(T.False, T.identity);
                    });
                    delete d.data;
                    d['data'] = servicesWithoutConflict;
                    return d;
                });
    },

    clearFilters: function() {
        Ext.getStore('overview_services_store').clearFilter(true);
        Ext.getStore('overview_store').clearFilter(true);
    },

    hasId: function(host) {
        return ! (host.hostId === '' || host.hostId === undefined || host.hostId === null);
    },

    responseHandler: function(response) {
        var res = Ext.encode(response.responseText);
    },

    destroyApp: function() {
        parent.Ext.getCmp('global_config_window').destroy()
    },

    IdentityClone: function(x) {
        return Ext.clone(x);
    },

    getSelection: function(id) {
        return Ext.ComponentQuery.query(id)[0].down('gridpanel').getSelectionModel();
    },

    getHostsSelected: function() {
        return this.getSelection('#hosts_modified').getSelection();
    },

    getServicesSelected: function() {
        return this.getSelection('#services_created').getSelection();
    },

    selectHostsModified: function() {
        return this.select('#hosts_modified', 'overview_store', 'hosts');
    },

    selectHostsCreated: function() {
        return this.select('#hosts_created', 'overview_store', 'hosts');
    },

    selectServices: function() {
        return this.select('#services_created', 'overview_services_store', 'services');
    },

    select: function(selectionId, storeId, key) {
        var me = this,
            selection = me.getSelection(selectionId);

        var all = Ext.getStore(storeId).data.items
        .reduce(function(acc, curr) {
            var res = Ext.getStore('license').canSelectRecord(key, curr);
            var keyAcc = (res.error ? 'error' : 'success');
            acc[keyAcc] = (acc[keyAcc] || []).concat(Ext.apply(res, {record: curr}));
            return acc;
        }, {});

        var toSelect = (all.success || [])
            .map(function(curr) { return curr.record; })
            .filter(function(curr) { return curr.get('isSelected'); });

        (all.error || []).forEach(function(curr) {
            var nodo		= selection.view.getNodeByRecord(curr.record);
            var id			= selection.view.getRowId(curr.record);
            var tooltip		= new Ext.ToolTip(
                { target: id,
                  html: curr.message });

            selection.deselect(curr.record, true);
            nodo.style.opacity = '.3';
        });

        (all.success || []).forEach(function(curr) {
            var nodo = selection.view.getNodeByRecord(curr.record);
            nodo.style.opacity = '1';
        });

        selection.select(toSelect, false, true);

        return all;
    },

    updateLicenseCmp: function(key) {
        var store	 	= Ext.getStore('license');
        var used 		= store.getConfiguringData(key).count();
        var available 	= store.getLicense().get(key).available;

        return model_wiz.helpers.Stream.publish('licenses', [used, available], 'select_change_'.concat(key));
    },

    updateAccordionHeader: function(key, header) {
        var store	 	= Ext.getStore('license');
        var used 		= store.configuringData[key].count();
        var fromNull 	= model_wiz.helpers.Utils.fromNullable;
        var tail	 	= model_wiz.helpers.Utils.tail;

        fromNull(header)
        .chain(function(header) {
            return fromNull(header.setTitle.bind(header));
        })
        .ap(
            fromNull(header.title)
            .map(function(title) {
                return title.split(' ');
            })
            .map(function(arr) {
                return [used].concat(tail(arr));
            })
            .map(function(arr) {
                return arr.join(' ');
            })
        )
        .fold(model_wiz.helpers.Utils.identity, model_wiz.helpers.Utils.identity);
    },

    rollbackOriginalServices: function() {
        var T = model_wiz.helpers.Utils;

        var F = model_wiz.Functor;

        T.getStore('original_services')
            .chain(T.safePluck(['data', 'items']))
            .map(function(xs) {
                return xs.map(function(x) {
                    return F.Right.of(T.curry(function(h,s) {
                            return T.setRecord('services', s, h);
                        }))
                        .ap(T.compose(T.chain(T.findRecord('selected_hosts_store', 'host_name')), T.safePluck(['data', 'host_reference'])) (x))
                        .ap(T.safePluck(['data', 'services'], x))
                        .chain(T.identity);
                });
            });
    },

    init: function(application) {
        var me 					= this;
        var Stream 				= model_wiz.helpers.Stream;
        var bind 				= model_wiz.helpers.Stream.bind;
        var trace 				= model_wiz.helpers.Stream.trace;
        var Navbar 				= this.getController('Navbar');
        var SetupParameters		= this.getController('steps.nav.SetupParameters');
        var license 			= Ext.getStore('license');

        Stream.subscribe('overview', this.createOverview, 'create_overview')
            .then(bind(Navbar.enableLoadingMask, false))
            .then(bind(Navbar.setNextBtnText, Ext.locale.translate('Finish')));

        Stream.subscribe('overview', bind(Navbar.enableNext, false), 'on_next')
            .then(bind(Navbar.enableBack, false))
            .then(bind(Navbar.enableLoadingMask, true))
            .then(this.clearFilters)
            .then(function() { license.getOverviewData('hosts').forEach(license.deselectRelatedServices.bind(license)); })
            .then(this.createData)
            .then(function (x) {console.log(x); return x;})
            .then(this.insertIconPath)
            .then(bind(this.postData, this.success));

        Stream.subscribe('overview', this.rollbackOriginalServices, 'on_back')
            .then(this.clearStores)
            .then(this.backToSetup)
            .then(bind(Navbar.setNextBtnText, Ext.locale.translate('Next')))
            .then(bind(Navbar.enableBack, true))
            .then(SetupParameters.getActiveTab)
            .then(SetupParameters.validateForm.bind(SetupParameters))
            .then(Navbar.enableNext);

        Stream.subscribe('overview', bind(Navbar.enableLoadingMask, false), 'finish_process')
            .then(this.destroyApp);

        Stream.subscribe('overview', function(key) {
            var key = {
                'hosts_created' 	: me.selectHostsCreated.bind(me),
                'services_created' 	: me.selectServices.bind(me),
                'hosts_modified'	: me.selectHostsModified.bind(me)
            };
            var active = Ext.ComponentQuery.query('#detailsCard')[0].layout.getActiveItem().layout.getExpanded()[0];

            if (active && key[active.itemId]) key[active.itemId]();
        }, 'update_grid');
    }

});
