/*
 * File: app/controller/steps/nav/SetupParameters.js
 *
 * This file was generated by Sencha Architect version 4.2.3.
 * http://www.sencha.com/products/architect/
 *
 * This file requires use of the Ext JS 4.2.x library, under independent license.
 * License of Sencha Architect does not include license for Ext JS 4.2.x. For more
 * details see http://www.sencha.com/license or contact license@sencha.com.
 *
 * This file will be auto-generated each and everytime you save your project.
 *
 * Do NOT hand edit this file.
 */

Ext.define('model_wiz.controller.steps.nav.SetupParameters', {
    extend: 'Ext.app.Controller',

    nextTab: function(activeTab) {
        return (function find(tab) {
            if (tab && ! tab.isDisabled()) {
                return tab;
            }
            return tab ? find(tab.next()) : null;
        })(activeTab.next());
    },

    prevTab: function(activeTab) {
        return (function find(tab) {
            if (tab && ! tab.isDisabled()) {
                return tab;
            }
            return tab ? find(tab.prev()) : null;
        })(activeTab.prev());
    },

    validateForm: function(activeTab) {
        return activeTab.form.isValid() && ! this.hasAnyDisabled(activeTab);
    },

    getActiveTab: function() {
        return Ext.getCmp('modelstepstabbar').getActiveTab();
    },

    setActiveTab: function(tab) {
        Ext.getCmp('modelstepstabbar').setActiveTab(tab);
        return tab;
    },

    findTab: function(name) {
        return (
            function findByName(tab) {
                return (tab && tab.title.toLowerCase() === name.toLowerCase())
                    ? tab
                    : (! tab) ? null : findByName(tab.next());
            }
        ) (this.getActiveTab());
    },

    clickTab: function(tab) {
        tab.tab.el.dom.click();
        return tab;
    },

    enableTab: function(tab) {
        tab.setDisabled(false);
        return tab;
    },

    chooseNextStep: function(tab) {
        var step = tab !== null ? 'go_next_tab' : 'go_overview';
        model_wiz.app.getController('Navbar').triggerStep('setup_parameters', [], step);
        return step;
    },

    choosePrevStep: function(tab) {
        var step = tab !== null ? 'go_prev_tab' : 'prev_step';
        model_wiz.app.getController('Navbar').triggerStep('setup_parameters', [], step);
        return step;
    },

    prevStep: function() {
        Ext.getCmp('step_03_accordion').items.each(function(curr) { curr.destroy(); });
    },

    getGlobalsAndLocals: function() {
        var fieldsController = model_wiz.app.getController('steps.card.Fields');
        var hosts = fieldsController.getSelectedHosts().data.items.map(function(curr) { return curr.data; });
        var globals = hosts.reduce(function(acc,curr) { return Ext.apply(acc, curr.globalparams); }, {});
        var locals = hosts
                     .map(function(curr) { return Ext.apply(curr.services, curr.services_created); })
                     .map(function(curr) { return Object.keys(curr)
                                                  .map(function(key) { return curr[key].localparams; }); })
                     .reduce(function(acc,curr) { return acc.concat(curr); }, [])
                     .reduce(function(acc,curr) { return Ext.apply(acc, curr); }, {});

        return Ext.apply(globals, locals);
    },

    getStoresCreated: function(all) {
        return Object.keys(all).map(function(key) { return all[key].name.concat('Store'); });
    },

    getStreamIds: function(all) {
        return (Object.keys(all) || []).map(function(key) { return all[key].name; });
    },

    removeStores: function(stores) {
        var allStoreKeys = Ext.data.StoreManager.keys;
        var storesFinded = stores.filter(function(currToDelete) {
            return allStoreKeys.some(function(currExistStore) { return currToDelete === currExistStore; });
        });

        storesFinded.forEach(function(curr) {
            var store = Ext.getStore(curr);
            if (store) {
                store.destroyStore();
            }
        });

        return storesFinded;
    },

    removeStreamEvents: function(data) {
        var Stream = model_wiz.helpers.Stream;
        var Fields = model_wiz.app.getController('steps.card.Fields');

        return data.map(function(topic) {
            var t = Fields.ajustStreamTopic(topic);
            return Stream.unsubscribe(t, Stream.getTopicIds(t));
        });
    },

    backToHostSelect: function() {
        this.getController('Navbar').setActiveCards({
            "container": "step_02",
            "header": "step_02_header"
        });
    },

    backToModelSelect: function() {
        this.getController('Navbar').setActiveCards({
            "container": "step_01",
            "header": "step_01_header"
        });
    },

    goOverview: function() {
        this.getController('Navbar').setActiveCards({
            'container': 'step_04',
            'header': 'step_04_header'
        });
    },

    createParams: function() {
        var hostStore = Ext.getStore('selected_hosts_store');
        var modelStore = Ext.getStore('selected_models_store');

        var hosts = hostStore.data.items.map(
            function(host) {
                return host.data;
            }
        );
        var ids = modelStore.data.items.map(
            function(m){
                return m.data.id;
            }
        );

        return {
            model: model_wiz.helpers.Utils.head(ids),
            data: JSON.stringify(hosts)
        };
    },

    mapperRequest: function(f, p) {
        Ext.getStore("treeStore").load({
            params: p,
            callback: f.bind(null, p)
        });
    },

    hasAnyDisabled: function(tab) {
        return !!this.getDisabledInputs(tab).length;
    },

    getDisabledInputs: function(tab) {
        return tab.form.getFields()
            .items
            .filter(function(item) {
                return ! item.xtype.match(/^displayfield/) && item.isDisabled();
            });
    },

    isValidInputs: function(tab, inputs) {
        return [].concat(inputs)
            .reduce(function(acc, input) {
                return acc
                    ? tab.form.getFields().items
                        .filter(function(item) {
                            return item.name === input;
                        })
                        .reduce(function(acc, field) {
                            return field.isValid();
                        }, true)

                    : acc;
            }, true);
    },

    isValidInputs2: function(inputs) {
        var me = this;
        var T = model_wiz.helpers.Utils;


        var getAllTabs = function() {
            return me.tabsFindedMemoization || (me.tabsFindedMemoization = (
                function recursion(tab, acc) {
                    return (tab === null) || (tab === undefined)
                        ? acc
                        : recursion(tab.next(), acc.concat(tab));
                }
            ) (me.findFirstTab(), []), me.tabsFindedMemoization);
        };

        var getAllInputs = function() {
            return me.inputsFindedMemoization || (me.inputsFindedMemoization = getAllTabs().reduce(function(acc, curr) {
                    return T.compose(T.concat(acc), T.pluck('items')) (curr.form.getFields());
                }, []), me.inputsFindedMemoization);
        };

        return getAllInputs().filter(function(currFromAll) {
                return inputs.some(function(currToFind) {
                    return currFromAll.name === currToFind;
                });
            })
            .reduce(function(acc, field) {
                return (acc === true) ? field.isValid() : false;
            }, true);

    },

    findFirstTab: function(currentTab) {
        var prev = currentTab ? currentTab.prev() : this.getActiveTab();
        if (prev) {
            return this.findFirstTab(prev);
        }
        return currentTab;
    },

    findTabEnabled: function(currentTab) {
        if (! this.findFirstTab().next()) return true;

        var next = currentTab ? currentTab.next() : this.findFirstTab().next();
        if (next) {
            return next.isDisabled() ? this.findTabEnabled(next) : true;
        }
        return false;
    },

    validateEveryTab: function() {
        var me = this;

        return (
            function validate(tab) {
                if (! tab) return true;
                return me.validateForm(tab)
                    ? validate(me.nextTab(tab))
                    : tab;
            }
        ) (this.findFirstTab());
    },

    removeServicesMarked: function() {
        var T = model_wiz.helpers.Utils;

        var F = model_wiz.Functor;

        var getServices = function(rec) {
            return T.fromNullable(rec)
                .chain(T.safePluck('get'))
                .map(T.bindContext(rec))
                .chain(function(f) { return T.tryCatch(function() { return f('services'); }); });
        };

        var filterRemoveServices = T.curry(function(flag, services) {
            return T.fromNullable(services)
                .map(T.curry(function(s,xs) {
                    return xs.reduce(function(acc,k) {
                        return acc.chain(function(a) {
                            return T.fromNullable(s)
                                .chain(T.safePluck(k))
                                .chain(T.ifElse(flag ? T.isPropertyFalse('remove') : T.isPropertyTrue('remove'), F.Left.of, F.Right.of))
                                .map(function(service) { return (a[k] = service, a); })
                                .leftMap(function() { return F.Right.of(a); });
                        });
                    }, model_wiz.Functor.Right.of({}));
                }))
                .ap(T.fromNullable(services).map(function(s) { return Object.keys(s); }))
                .chain(T.identity);
        });

        var filterServicesToRemove = filterRemoveServices(true);

        var filterServicesToNotRemove = filterRemoveServices(false);

        Ext.getStore('selected_hosts_store').each(function(curr) {
            // Storing original services
            getServices(curr)
                .chain(filterServicesToRemove)
                .chain(T.safeClone)
                .map(T.curry(function(xs, h) { return T.safeApply({}, {services: xs, host_reference: h}); }))
                .ap(T.safePluck(['data', 'host_name'], curr))
                .chain(T.identity)
                .chain(T.addRecord('original_services'));

            // Removing necessary services
            T.fromNullable(T.setRecord('services'))
                .ap(T.compose(T.chain(filterServicesToNotRemove), getServices) (curr))
                .ap(T.fromNullable(curr));
        });
    },

    joinServicesCreated: function() {
        var T = model_wiz.helpers.Utils;

        var F = model_wiz.Functor;

        var combineServices = function(rec) {
            return T.fromNullable(T.curry(function(f,g,x,y) {
                    return T.tryCatch(function() { return f(g(x), g(y)); }).chain(T.identity);
                }))
                .ap(F.Right.of(T.safeApply))
                .ap(T.getRecordFn('get', rec))
                .ap(F.Right.of('services'))
                .ap(F.Right.of('services_created'))
                .chain(T.identity);
        };

        Ext.getStore('selected_hosts_store').each(function(curr) {
            T.fromNullable(T.setRecord('services'))
                .ap(combineServices(curr))
                .ap(T.fromNullable(curr));
        });
    },

    init: function(application) {

        var me 					= this;
        var Stream 				= model_wiz.helpers.Stream;
        var bind 				= model_wiz.helpers.Stream.bind;
        var trace 				= model_wiz.helpers.Stream.trace;
        var Navbar 				= this.getController('Navbar');
        var Overview 			= this.getController('steps.nav.Overview');

        Stream.subscribe('setup_parameters', this.getActiveTab, 'on_next')
            .then(this.nextTab)
            .then(this.chooseNextStep);

        Stream.subscribe('setup_parameters', this.getActiveTab, 'on_back')
            .then(this.prevTab)
            .then(this.choosePrevStep);

        Stream.subscribe('setup_parameters', this.prevStep, 'prev_step')
            .then(this.getGlobalsAndLocals)
            .then(function(all) {
                model_wiz.helpers.Utils.compose(me.removeStreamEvents, me.getStreamIds) (all);
                model_wiz.helpers.Utils.compose(me.removeStores, me.getStoresCreated) (all);
                Ext.getStore('services_created_tmp').removeAll();
                Ext.getStore('original_hosts_selected').removeAll();
                me.tabsFindedMemoization = undefined;
                me.inputsFindedMemoization = undefined;
                return all;
            });

        Stream.subscribe('setup_parameters', this.backToHostSelect, 'back_to_host_select')
            .then(this.getController('steps.nav.HostSelect').hasAnyHostSelected)
            .then(Navbar.enableNext);

        Stream.subscribe('setup_parameters', this.backToModelSelect, 'back_to_model_select')
            .then(trace('teste'))
            .then(this.getController('steps.nav.ModelSelect').hasAnySelected)
            .then(Navbar.enableNext);

        Stream.subscribe('setup_parameters', this.getActiveTab, 'go_next_tab')
            .then(this.nextTab)
            .then(this.enableTab)
            .then(this.setActiveTab)
            .then(this.clickTab);

        Stream.subscribe('setup_parameters', this.getActiveTab, 'go_prev_tab')
            .then(this.prevTab)
            .then(this.enableTab)
            .then(this.setActiveTab)
            .then(this.clickTab);

        Stream.subscribe('setup_parameters', this.getActiveTab, 'validate_form')
            .then(this.validateForm)
            .then(function(flag) { return (flag  && me.findTabEnabled()); })
            .then(Navbar.enableNext);

        Stream.subscribe('setup_parameters', this.validateEveryTab, 'go_overview')
            .then(function(flag) {
                if (flag === true) return Stream.publish('setup_parameters', [], 'change_to_overview', me);
                return Stream.publish('setup_parameters', flag, 'change_to_invalid_tab', me);
            });

        Stream.subscribe('setup_parameters', bind(Navbar.enableLoadingMask, true), 'change_to_overview')
            .then(this.removeServicesMarked)
            .then(this.joinServicesCreated)
            .then(this.createParams)
            .then(trace('Objeto'))
            .then(bind(this.mapperRequest, Overview.active))
            .then(this.goOverview);

        Stream.subscribe('setup_parameters', this.setActiveTab, 'change_to_invalid_tab')
            .then(function(tab) {
                return tab.form.getFields()
                    .items
                    .filter(function(item) {
                        return item.validate() === false;
                    });
            })
            .then(function(inputs) {
                inputs.forEach(function(curr) {
                    var field = curr.up().down('displayfield');
                    field.show().setValue(curr.validator()).addCls('error-message');
                });
            });
    }

});
