/*
 * File: app/store/all_models_store.js
 *
 * This file was generated by Sencha Architect version 4.2.3.
 * http://www.sencha.com/products/architect/
 *
 * This file requires use of the Ext JS 4.2.x library, under independent license.
 * License of Sencha Architect does not include license for Ext JS 4.2.x. For more
 * details see http://www.sencha.com/license or contact license@sencha.com.
 *
 * This file will be auto-generated each and everytime you save your project.
 *
 * Do NOT hand edit this file.
 */

Ext.define('model_wiz.store.all_models_store', {
    extend: 'Ext.data.Store',

    requires: [
        'model_wiz.model.models_model',
        'Ext.data.proxy.Ajax',
        'Ext.data.reader.Json'
    ],

    constructor: function(cfg) {
        var me = this;
        cfg = cfg || {};
        me.callParent([Ext.apply({
            autoLoad: true,
            model: 'model_wiz.model.models_model',
            storeId: 'all_models_store',
            proxy: {
                type: 'ajax',
                url: '/opmon/seagull/www/index.php/models/action/get_all_models/',
                reader: {
                    type: 'json',
                    root: 'data'
                }
            },
            listeners: {
                load: {
                    fn: me.onStoreLoad,
                    scope: me
                }
            }
        }, cfg)]);
    },

    onStoreLoad: function(store, records, successful, eOpts) {
        var tag_store = Ext.getStore("categories_store");
        var tag_suggested_store = Ext.getStore("categories_suggested_store");
        var tagsToAdd = [];
        var flatten = model_wiz.helpers.Utils.flatten;

        for (i = 0; i < records.length; i++) {
            var tags = records[i].data.tags;
            var exists = null;
            for (t = 0; t < tags.length; t++) {
                tags[t].icon = records[i].data.name + "/" + tags[t].icon;
                tags[t].correlated_tags = flatten(records[i].data.services.map(function(curr) { return curr.tags; }))
                .reduce(function(acc, tag) {
                    return acc.some(function(x) { return (x.name.toLowerCase() === tag.name.toLowerCase()); })
                    ? acc
                    : acc.concat(tag);
                }, []);
                exists = tagsToAdd.some(function(a) {
                    return a.name.toLowerCase() === tags[t].name.toLowerCase();
                });
            }

            if (! exists) {
                tags.forEach(function(a) {
                    tagsToAdd.push(a);
                });
            }
        }

        if(parent.WIZZARD_CONFIG_PARAMS && parent.WIZZARD_CONFIG_PARAMS.hosts) {
            var filterTag = this.filterByTag(tagsToAdd);
            var hasAnyFiltered = filterTag.length > 0;
            var fn = hasAnyFiltered ? 'show' : 'hide';
            tag_suggested_store.add(filterTag);
            tag_store.add(tagsToAdd);
            Ext.getCmp('suggestedModels')[fn]();
            Ext.getCmp('suggestedSeparator')[fn]();
        }
        else {
            tag_store.add(tagsToAdd);
        }

        var svc_store = Ext.getStore("services_list_store");
        for (i = 0; i < records.length; i++) {
            var svc = records[i].data.services;

            svc_store.add(svc);
        }

        var cmpToShow = records.length ? "tagsmodelview" : "nomodel";
        Ext.getCmp(cmpToShow).show();
    },

    getFromSelectedHosts: function() {
        return parent.WIZZARD_CONFIG_PARAMS.hosts.reduce(function(acc, host) {
            return acc.concat(
                host.tags.filter(function(tag) {
                    return acc.indexOf(tag) === -1;
                })
                .map(function(curr){
                    return curr.toLowerCase();
                })
            );
        }, []);
    },

    filterByTag: function(objs) {
        var me = this;

        return objs.filter(function(o) {
            return me.getFromSelectedHosts().indexOf(o.name.toLowerCase()) > -1 || o.correlated_tags.some(function(currTag) { return me.getFromSelectedHosts().indexOf(currTag.name.toLowerCase()) > -1; });
        });
    }

});