/*
 * File: app/store/hosts.js
 *
 * This file was generated by Sencha Architect version 4.2.3.
 * http://www.sencha.com/products/architect/
 *
 * This file requires use of the Ext JS 4.2.x library, under independent license.
 * License of Sencha Architect does not include license for Ext JS 4.2.x. For more
 * details see http://www.sencha.com/license or contact license@sencha.com.
 *
 * This file will be auto-generated each and everytime you save your project.
 *
 * Do NOT hand edit this file.
 */

Ext.define('model_wiz.store.hosts', {
    extend: 'Ext.data.Store',

    requires: [
        'model_wiz.model.host_model',
        'Ext.data.proxy.Ajax',
        'Ext.data.reader.Json'
    ],

    constructor: function(cfg) {
        var me = this;
        cfg = cfg || {};
        me.callParent([Ext.apply({
            autoLoad: false,
            model: 'model_wiz.model.host_model',
            storeId: 'hosts',
            proxy: {
                type: 'ajax',
                url: '/opmon/seagull/www/index.php/models/action/get_all_hosts/',
                reader: {
                    type: 'json',
                    root: 'data'
                }
            },
            listeners: {
                load: {
                    fn: me.onStoreLoad,
                    scope: me
                },
                beforeload: {
                    fn: me.onStoreBeforeLoad,
                    scope: me
                }
            }
        }, cfg)]);
    },

    onStoreLoad: function(store, records, successful, eOpts) {
        if(parent.WIZZARD_CONFIG_PARAMS && parent.WIZZARD_CONFIG_PARAMS.from === 'discovery') {
            this.filterByHost();
        }else{
        //         this.filterByTag();
        //         if (this.getCount() === 0) {
        //             model_wiz.helpers.Stream.publish('host_select', Ext.ComponentQuery.query('#viewAllBtn')[0], 'view_all_hosts');
        //         }
        }
    },

    onStoreBeforeLoad: function(store, operation, eOpts) {
        if(parent.WIZZARD_CONFIG_PARAMS && parent.WIZZARD_CONFIG_PARAMS.from === 'discovery') {
            this.setProxy({
                type: 'ajax',
                url: '/opmon/seagull/www/index.php/discovery/action/hostbuckets/',
                reader: {
                    type: 'json',
                    root: 'data'
                }
            });
        }
        else {
            this.setProxy({
                type: 'ajax',
                url: '/opmon/seagull/www/index.php/models/action/get_all_hosts/',
                reader: {
                    type: 'json',
                    root: 'data'
                }
            });
        }
    },

    filterByTag: function() {
        var selected_model = Ext.getStore('selected_models_store');
        var flatten = model_wiz.helpers.Utils.flatten;

        this.filterBy(function(host) {
            var result = false;
            var tags_hosts = host.get('tags');
            if (tags_hosts) {
                tags_hosts.forEach(function(tag_host){
                    var tags_model = selected_model.data.items[0].data.tags;
                    var tags_model_services = selected_model.data.items[0].data.services.map(function(curr) { return curr.tags; });
                    var all_tags = tags_model.concat(flatten(tags_model_services));
                    all_tags.forEach(function(tag_model) {
                        if(tag_model.name.toLowerCase() === tag_host.toLowerCase()) {
                            result = true;
                        }
                    });
                });
            }
            return result;
        }, this);
    },

    filterByHost: function() {
        var selected_hosts = Ext.getStore('selected_hosts_store');
        var hosts_from_discovery = parent.WIZZARD_CONFIG_PARAMS.hosts;
        selected_hosts.removeAll();
        this.data.items.forEach(function(host){
            hosts_from_discovery.forEach(function(host_discovered){
                if(host_discovered.host_name === host.get('host_name')){
                    selected_hosts.add(host);

                }
            });
        });
        Ext.getCmp("host_selected_count_1").setValue(selected_hosts.count().toString().concat(" ").concat(Ext.locale.translate('host(s) selected')));
    }

});