/*
 * File: app/store/license.js
 *
 * This file was generated by Sencha Architect version 4.2.3.
 * http://www.sencha.com/products/architect/
 *
 * This file requires use of the Ext JS 4.2.x library, under independent license.
 * License of Sencha Architect does not include license for Ext JS 4.2.x. For more
 * details see http://www.sencha.com/license or contact license@sencha.com.
 *
 * This file will be auto-generated each and everytime you save your project.
 *
 * Do NOT hand edit this file.
 */

Ext.define('model_wiz.store.license', {
    extend: 'Ext.data.Store',

    requires: [
        'Ext.data.Field'
    ],

    constructor: function(cfg) {
        var me = this;
        cfg = cfg || {};
        me.callParent([Ext.apply({
            storeId: 'license',
            fields: [
                {
                    convert: function(v, rec) {
                        return (v.limit === 0)
                        ? Ext.apply(v, {available: Infinity})
                        : v;
                    },
                    name: 'hosts'
                },
                {
                    convert: function(v, rec) {
                        return (v.limit === 0)
                        ? Ext.apply(v, {available: Infinity})
                        : v;
                    },
                    name: 'services'
                },
                {
                    defaultValue: 0,
                    name: 'hostsUsed'
                },
                {
                    defaultValue: 0,
                    name: 'hostsExisting'
                },
                {
                    defaultValue: 0,
                    name: 'servicesUsed'
                },
                {
                    defaultValue: 0,
                    name: 'servicesExisting'
                }
            ],
            listeners: {
                add: {
                    fn: me.onStoreAdd,
                    scope: me
                }
            }
        }, cfg)]);
    },

    /* onStoreAdd :: (from Event) Store -> [Record] -> Number -> Event -> _ */
    onStoreAdd: function(store, records, index, eOpts) {
        var license = this.getLicense();
        var me = this;

        this.configuringData =
            { hosts				: me.getConfiguringData('hosts'),
              hostsExisting		: me.getConfiguringData('hosts', 'Existing'),
              services			: me.getConfiguringData('services'),
              servicesExisting	: me.getConfiguringData('services', 'Existing') };

        this.getOverviewData('hosts').forEach(this.selectData.bind(this, 'hosts'));
        this.getOverviewData('services').forEach(this.selectData.bind(this, 'services'));

        model_wiz.helpers.Stream.publish('licenses', [license.get('services').available, license.get('hosts').available], 'on_license_load');

        model_wiz.helpers.Stream.publish('licenses', [this.configuringData.hosts.count(), license.get('hosts').available], 'select_change_hosts');
        model_wiz.helpers.Stream.publish('licenses', [this.configuringData.services.count(), license.get('services').available], 'select_change_services');
    },

    /* validateRecord :: String -> Record -> Either String Record */
    validateRecord: function(key, record) {
        var me = this,
            Left = model_wiz.Functor.Left,
            Right = model_wiz.Functor.Right;

        return model_wiz.helpers.Utils.fromNullable(record)
            .chain(function(rec) {
                    return me.isSelected(rec)
                            .fold(function(_) { return Right.of(rec); },
                                  function(rec) { return Left.of('100'); });
            })
            .chain(me.verifyLicense.bind(me, key))
            .chain(function(rec) {
                    return (me.hostDependencyIsSelected(rec) === false)
                        ? Left.of('200')
                        : Right.of(rec);
            })
            .chain(function(rec) {
                    return rec.get('conflict')
                        ? Left.of('300')
                        : Right.of(rec);
            });
    },

    /* leftSelectDataResponse :: a -> b */
    leftSelectDataResponse: function(stats) {
        var fromNull = model_wiz.helpers.Utils.fromNullable;
        var me = this;
        // Codes :: Object {message: String, error: Boolean}
        var Codes = {
            '100': { message: Ext.locale.translate('Already selected'), error: false },
            '200': { message: Ext.locale.translate('Host service is not selected'), error: true },
            '300': { message: Ext.locale.translate('With conflict'), error: true },
            '400': { message: Ext.locale.translate('Already created'), error: false },
            '500': { message: Ext.locale.translate('License limit reached'), error: true },
            'default': { message: Ext.locale.translate('Error'), error: true }
        };

        return fromNull(stats)
            .chain(function(code) { return fromNull(Codes[code]); })
            .fold(function(_) { return Codes.default; },
                  function(err) { return err; });
    },

    /* rightSelectDataResponse :: a -> b */
    rightSelectDataResponse: function(stats) {
        return { error: false, message: Ext.locale.translate('Data selected successful') };
    },

    /* canSelectRecord :: String -> Record -> Either Object {err, msg} Object {err, msg} */
    canSelectRecord: function(key, record) {
        var me = this,
            Left = model_wiz.Functor.Left,
            Right = model_wiz.Functor.Right;

        return me.validateRecord(key, record)
                .fold(me.leftSelectDataResponse,
                      me.rightSelectDataResponse);
    },

    /* selectData :: String -> Record -> Either Object {err, msg} Object {err, msg} */
    selectData: function(key, record) {
        var me = this,
            Left = model_wiz.Functor.Left,
            Right = model_wiz.Functor.Right;

        return me.validateRecord(key, record)
                .map(function(rec) {
                    rec.data.isSelected = true;
                    return rec;
                })
                .chain(function(rec) {
                    return me.hasId(rec)
                            ? Left.of('400')
                            : Right.of(rec);
                })
                .bimap(
                    function(code) {
                        if (code === '300') me.configuringData.servicesExisting.inc();
                        return code;
                    },
                    model_wiz.helpers.Utils.identity
                )
                .bimap(
                    function(code) {
                        if (code === '400') me.configuringData.hostsExisting.inc();
                        return code;
                    },
                    model_wiz.helpers.Utils.identity
                )
                .map(function(rec) {
                    me.configuringData[key].inc();
                    return rec;
                })
                .fold(me.leftSelectDataResponse,
                      me.rightSelectDataResponse);
    },

    /* deselectData :: String -> Record -> Either False True */
    deselectData: function(key, record) {
        var me 				= this,
            Left 			= model_wiz.Functor.Left,
            Right 			= model_wiz.Functor.Right,
            identity 		= model_wiz.helpers.Utils.identity,
            fromTrue 		= model_wiz.helpers.Utils.fromTrue,
            bind 			= model_wiz.helpers.Utils.bind,
            fromNullable 	= model_wiz.helpers.Utils.fromNullable;

        return fromNullable(record)
                .map(function(rec) {
                    rec.data.isSelected = false;
                    return rec;
                })
                .chain(function(rec) {
                    return me.hasId(rec)
                            ? Left.of('400')
                            : Right.of(rec);
                })
                .bimap(
                    function(code) {
                        if (code === '400') me.configuringData.hostsExisting.dec();
                        return code;
                    },
                    model_wiz.helpers.Utils.identity
                )
                .map(function(rec) {
                    me.configuringData[key].dec();
                    return rec;
                })
                .mapBoth(function(codeOrRec) {
                        return (me.isHost(record))
                                .chain(
                                    bind(fromTrue, ((typeof codeOrRec !== 'string') || (codeOrRec === '400')))
                                )
                                .fold(model_wiz.helpers.Utils.identity.bind(null, codeOrRec),
                                      function(rec) {
                                          me.deselectRelatedServices(record);
                                          return codeOrRec;
                                      });
                })
                .fold(function(code) { return me.leftSelectDataResponse(code).error === false; },
                      model_wiz.helpers.Utils.True);
    },

    /* hasId :: Record -> Boolean */
    hasId: function(host) {
        return ! ((host.get('hostId') === '') || (host.get('hostId') === undefined) || (host.get('hostId') === null));
    },

    /* hostDependencie :: Record -> Boolean */
    hostDependencyIsSelected: function(record) {
        return record.data.hasOwnProperty('hostName')
                ? this.getOverviewData('hosts')
                    .reduce(function(acc, curr) {
                        return (acc === null) && (curr.get('name') === record.get('hostName'))
                                ? curr
                                : acc; }, null)
                    .get('isSelected')
                : true;
    },

    /* getLicense :: _ -> Record */
    getLicense: function() {
        return model_wiz.helpers.Utils.last(this.data.items);
    },

    /* numSelecteds :: String -> Number */
    numSelecteds: function(key) {
        var me = this;
        return this.getOverviewData(key)
                .filter(function(curr) {
                    return curr.get('isSelected') && ! me.hasId(curr); })
                .length;
    },

    /* getOverviewData :: String -> [Records] */
    getOverviewData: function(key) {
        var store = (key === 'hosts')
            ? Ext.getStore('overview_store')
            : Ext.getStore('overview_services_store');

        return (store.snapshot) ? store.snapshot.items : store.data.items;
    },

    /* deselectRelatedServices :: Record -> _ */
    deselectRelatedServices: function(record) {
        var me = this;
        var datas = this.getOverviewData('services');
        datas.forEach(function(curr) {
            var someServiceWithSameName =
                record.get('data')
                    .some(function(d) {
                        return (d.name === curr.get('name')) && (d.hostName === curr.get('hostName'));
                    });

            if (someServiceWithSameName && curr.get('isSelected') && ! record.get('isSelected')) {
                curr.set('isSelected', false);
                /*if (! me.hasId(record))*/ me.configuringData.services.dec();
            }
        });
    },

    /* verifyLicense :: String -> Record -> Either String Record */
    verifyLicense: function(key, record) {
        var avail 			= this.getLicense().get(key).available;
        var configuring		= this.getConfiguringData(key).count();

        return (this.hasId(record)) || (configuring < avail)
                ? model_wiz.Functor.Right(record)
                : model_wiz.Functor.Left('500');
    },

    /* getConfiguringData :: String -> Object */
    getConfiguringData: function(key, sufix) {
        var me = this;
        var license = me.getLicense();
        var keyData = key.concat(sufix || 'Used');
        var increment = model_wiz.helpers.Utils.add.bind(null, 1);
        var decrement = model_wiz.helpers.Utils.add.bind(null, -1);

        return {
            count: function() { return license.get(keyData); },

            inc: function() {
                var plus = increment(license.get(keyData));
                license.data[keyData] = plus;
                if (plus === license.get(key).available) model_wiz.helpers.Stream.publish('overview', key, 'update_grid');
                return plus; },

            dec: function() {
                var plus = decrement(license.get(keyData));
                license.data[keyData] = plus;
                if (plus === decrement(license.get(key).available)) model_wiz.helpers.Stream.publish('overview', key, 'update_grid');
                return plus; }
        };
    },

    /* getSelecteds :: String -> [Record] */
    getSelecteds: function(key) {
        var me = this;
        return this.getOverviewData(key)
               .filter(function(curr) {
                   return (curr.get('isSelected')) && (! me.hasId(curr));
               });
    },

    /* isSelected :: Record -> Either Record Record */
    isSelected: function(record) {
        return (record.get('isSelected') === false)
                ? model_wiz.Functor.Left(record)
                : model_wiz.Functor.Right(record);
    },

    /* isHost :: Record -> Either Record Record */
    isHost: function(record) {
        return (record.hasOwnProperty('data') === false || record.data.hasOwnProperty('hostId') === false)
                ? model_wiz.Functor.Left(record)
                : model_wiz.Functor.Right(record);
    }

});