/*
 * File: app/view/components/ResolveConflict.js
 *
 * This file was generated by Sencha Architect version 4.2.3.
 * http://www.sencha.com/products/architect/
 *
 * This file requires use of the Ext JS 4.2.x library, under independent license.
 * License of Sencha Architect does not include license for Ext JS 4.2.x. For more
 * details see http://www.sencha.com/license or contact license@sencha.com.
 *
 * This file will be auto-generated each and everytime you save your project.
 *
 * Do NOT hand edit this file.
 */

Ext.define('model_wiz.view.components.ResolveConflict', {
    extend: 'Ext.window.Window',
    alias: 'widget.components.resolveconflict',

    requires: [
        'Ext.form.field.Text',
        'Ext.toolbar.Toolbar',
        'Ext.button.Button'
    ],

    id: 'resolveConflict',
    width: 400,
    title: Ext.locale.translate('Resolve conflict'),
    modal: true,

    initComponent: function() {
        var me = this;

        Ext.applyIf(me, {
            items: [
                {
                    xtype: 'textfield',
                    validator: function(value) {
                        var win = this.up('window');
                        var btn = win.down('#renameButton');
                        if(value.toLowerCase() === win.record.get('name').toLowerCase()) {
                            btn.setDisabled(true);
                            return Ext.locale.translate('Invalid name');
                        }
                        btn.setDisabled(false);
                        return true;
                    },
                    itemId: 'renameInput',
                    margin: 10,
                    fieldLabel: Ext.locale.translate('Rename service'),
                    listeners: {
                        beforerender: {
                            fn: me.onRenameInputBeforeRender,
                            scope: me
                        }
                    }
                }
            ],
            dockedItems: [
                {
                    xtype: 'toolbar',
                    dock: 'bottom',
                    items: [
                        {
                            xtype: 'container',
                            flex: 1
                        },
                        {
                            xtype: 'button',
                            text: Ext.locale.translate('Cancel'),
                            listeners: {
                                click: {
                                    fn: me.onButtonClick,
                                    scope: me
                                }
                            }
                        },
                        {
                            xtype: 'container',
                            items: [
                                {
                                    xtype: 'button',
                                    disabled: true,
                                    itemId: 'renameButton',
                                    text: Ext.locale.translate('Rename'),
                                    listeners: {
                                        click: {
                                            fn: me.onRenameButtonClick,
                                            scope: me
                                        }
                                    }
                                }
                            ]
                        }
                    ]
                }
            ]
        });

        me.callParent(arguments);
    },

    onRenameInputBeforeRender: function(component, eOpts) {
        component.setValue(this.record.get('name'));
    },

    onButtonClick: function(button, e, eOpts) {

        this.callback(false);
    },

    onRenameButtonClick: function(button, e, eOpts) {
        var input = this.down('#renameInput');
        var me = this;
        var store = Ext.getStore('overview_store');

        store.clearFilter(true);
        store
        .findRecord('name', me.record.get('hostName'))
        .get('data')
        .forEach(function(x) {
            if (x.name === me.record.get('name')) {
                x.name = input.getValue();
                x.conflict = false;
                x.serviceId = null;
                Ext.getStore('license').configuringData.servicesExisting.dec();
                model_wiz.app.getController('steps.nav.Overview').updateAccordionHeader('servicesExisting', Ext.getCmp('services_conflict').down());
            }
        });

        this.record.set('name', input.getValue());
        this.record.set('conflict', false);
        this.record.set('serviceId', null);

        Ext.MessageBox.confirm({
            title: Ext.locale.translate('Conflict resolved'),
            msg: Ext.locale.translate('Do you want to select this service?'),
            buttons: Ext.MessageBox.YESNO,
            buttonText	: {yes: Ext.locale.translate('Select service'), no: Ext.locale.translate('Do not select service')},
            icon: Ext.MessageBox.INFO,
            width: 400,
            fn: function(res) {
                if(res === 'yes') {
                    var selectResponse = Ext.getStore('license').selectData('services', me.record);

                    if (selectResponse.error) {
                        Ext.MessageBox.alert({
                            msg: selectResponse.message,
                            title: Ext.locale.translate('Service is not selected'),
                            buttons: Ext.MessageBox.OK,
                            buttonText	: {ok: 'Ok'},
                            icon: Ext.MessageBox.INFO,
                            width: 400
                        });
                    }
                    else {
                        model_wiz.app.getController('steps.nav.Overview').updateAccordionHeader('services', Ext.getCmp('services_created').down());
                    }
                }
            }
        });

        this.callback(true);
    }

});