/*
 * File: app/view/fields/multiple.js
 *
 * This file was generated by Sencha Architect version 4.2.3.
 * http://www.sencha.com/products/architect/
 *
 * This file requires use of the Ext JS 4.2.x library, under independent license.
 * License of Sencha Architect does not include license for Ext JS 4.2.x. For more
 * details see http://www.sencha.com/license or contact license@sencha.com.
 *
 * This file will be auto-generated each and everytime you save your project.
 *
 * Do NOT hand edit this file.
 */

Ext.define('model_wiz.view.fields.multiple', {
    extend: 'Ext.form.FieldContainer',
    alias: 'widget.fieldsmultiple',

    requires: [
        'Ext.form.FieldContainer',
        'Ext.form.field.Display',
        'Ext.form.field.ComboBox',
        'Ext.ProgressBar'
    ],

    margin: '0 0 20',
    width: 450,
    layout: 'hbox',
    fieldLabel: '',
    labelSeparator: ' ',
    labelWidth: 150,

    initComponent: function() {
        var me = this;

        Ext.applyIf(me, {
            items: [
                {
                    xtype: 'fieldcontainer',
                    padding: '0 10 0 0',
                    width: 200,
                    fieldLabel: Ext.locale.translate('multiselect'),
                    labelAlign: 'top',
                    layout: {
                        type: 'vbox',
                        align: 'stretch'
                    },
                    items: [
                        {
                            xtype: 'displayfield',
                            cls: 'field-description',
                            value: Ext.locale.translate('description')
                        }
                    ]
                },
                {
                    xtype: 'fieldcontainer',
                    flex: 1,
                    maxWidth: 450,
                    layout: {
                        type: 'vbox',
                        align: 'stretch'
                    },
                    items: [
                        {
                            xtype: 'boxselect',
                            inputType: 'multiple',
                            stacked: true,
                            flex: 1,
                            fieldLabel: '',
                            name: 'input',
                            triggerCls: 'x-form-search-trigger',
                            anyMatch: true,
                            displayField: 'key',
                            forceSelection: true,
                            multiSelect: true,
                            queryMode: 'local',
                            store: 'comboMultipleStore',
                            valueField: 'value',
                            listeners: {
                                blur: {
                                    fn: me.change,
                                    scope: me
                                },
                                beforedeselect: {
                                    fn: me.onComboboxBeforeDeselect,
                                    scope: me
                                }
                            }
                        },
                        {
                            xtype: 'progressbar',
                            flex: 1,
                            height: 2,
                            hidden: true,
                            value: 0.4
                        },
                        {
                            xtype: 'displayfield',
                            flex: 1,
                            cls: 'field-description',
                            hidden: true,
                            value: Ext.locale.translate('return')
                        }
                    ]
                }
            ]
        });

        me.callParent(arguments);
    },

    change: function(component, e, eOpts) {
        this.forward(component,'record');
    },

    onComboboxBeforeDeselect: function(combo, record, index, eOpts) {
        var service = record.get('key').toLowerCase();
        var T = model_wiz.helpers.Utils;

        Ext.getStore('selected_hosts_store').each(function(host) {
            host.set('services_created', Object.keys(host.get('services_created')).reduce(function(acc, key) {
                return (host.get('services_created')[key].reference.toLowerCase() === service.toLowerCase())
                    ? acc
                    : (acc[key] = host.get('services_created')[key], acc);
            }, {}));
        });
    },

    forward: function(child, event) {
        var parent_step = this.up('modelstep');
        parent_step.forward(child,event);
    },

    setDescription: function(text) {
        this.items.items[0].items.items[0].setValue(text);
    },

    setFieldLabel: function(text) {
        this.items.items[0].setFieldLabel(text);
    },

    setFieldName: function(name) {
        Ext.apply(this.items.items[1].items.items[0], {name: name});
    },

    setFieldValue: function(value) {
        this.items.items[1].items.items[0].setValue(value);
    },

    setMandatory: function() {
        this.items.items[1].items.items[0].validator = function(val) {
            return (val !== null) && (val !== undefined) && (val !== "")
                ? true
                : Ext.locale.translate('This field is mandatory');
        };
    },

    getFieldValue: function() {
        return this.items.items[1].items.items[0].getValue();
    },

    getFieldName: function() {
        return this.items.items[1].items.items[0].getName();
    },

    getFieldCombo: function() {
        return this.items.items[1].items.items[0];
    },

    setFieldEnable: function() {
        this.items.items[1].items.items[0].enable();
    },

    setFieldDisable: function() {
        this.items.items[1].items.items[0].disable();
    },

    setTooltip: function(text) {
        new Ext.ToolTip({
            target: this.items.items[1].items.items[0].getEl(),
            html: text
        });
    },

    unsetValidate: function() {
        Ext.apply(this.items.items[1].items.items[0], {validator: function(value){
            return true;
        }});
    }

});