/*
 * File: app/view/fields/select.js
 *
 * This file was generated by Sencha Architect version 4.2.3.
 * http://www.sencha.com/products/architect/
 *
 * This file requires use of the Ext JS 4.2.x library, under independent license.
 * License of Sencha Architect does not include license for Ext JS 4.2.x. For more
 * details see http://www.sencha.com/license or contact license@sencha.com.
 *
 * This file will be auto-generated each and everytime you save your project.
 *
 * Do NOT hand edit this file.
 */

Ext.define('model_wiz.view.fields.select', {
    extend: 'Ext.form.FieldContainer',
    alias: 'widget.fieldsselect',

    requires: [
        'Ext.form.FieldContainer',
        'Ext.form.field.Display',
        'Ext.form.field.ComboBox',
        'Ext.ProgressBar'
    ],

    margin: '0 0 15',
    width: 450,
    fieldLabel: '',
    labelSeparator: ' ',
    labelWidth: 150,

    layout: {
        type: 'hbox',
        align: 'stretch'
    },

    initComponent: function() {
        var me = this;

        Ext.applyIf(me, {
            items: [
                {
                    xtype: 'fieldcontainer',
                    padding: '0 10 0 0',
                    width: 200,
                    fieldLabel: Ext.locale.translate('select'),
                    labelAlign: 'top',
                    layout: {
                        type: 'vbox',
                        align: 'stretch'
                    },
                    items: [
                        {
                            xtype: 'displayfield',
                            cls: 'field-description',
                            value: Ext.locale.translate('description')
                        }
                    ]
                },
                {
                    xtype: 'fieldcontainer',
                    flex: 1,
                    maxWidth: 450,
                    layout: {
                        type: 'vbox',
                        align: 'stretch'
                    },
                    items: [
                        {
                            xtype: 'combobox',
                            inputType: 'select',
                            margin: '2 0 0',
                            width: 220,
                            fieldLabel: Ext.locale.translate('Select or create an authention to access the host(s)'),
                            hideLabel: true,
                            labelAlign: 'top',
                            labelCls: 'x-form-item-label fiel-description',
                            labelSeparator: ' ',
                            labelWidth: 150,
                            displayField: 'key',
                            forceSelection: true,
                            queryMode: 'local',
                            store: 'comboSelectStore',
                            valueField: 'value',
                            listeners: {
                                change: {
                                    fn: me.Change,
                                    scope: me
                                }
                            }
                        },
                        {
                            xtype: 'progressbar',
                            height: 2,
                            hidden: true,
                            value: 0.4
                        },
                        {
                            xtype: 'displayfield',
                            flex: 1,
                            cls: 'field-description',
                            hidden: true,
                            value: Ext.locale.translate('return')
                        }
                    ]
                }
            ]
        });

        me.callParent(arguments);
    },

    Change: function(field, newValue, oldValue, eOpts) {
        this.forward(field,'record');
    },

    forward: function(child,event) {
        var parent_step = this.up('modelstep');
        parent_step.forward(child,event);
    },

    setDescription: function(text) {
        this.items.items[0].items.items[0].setValue(text);
    },

    setFieldLabel: function(text) {
        this.items.items[0].setFieldLabel(text);
    },

    setFieldName: function(name) {
        Ext.apply(this.items.items[1].items.items[0], {name: name});
    },

    setFieldValue: function(value) {
        this.items.items[1].items.items[0].setValue(value);
    },

    setMandatory: function() {
        this.items.items[1].items.items[0].validator = function(val) {
            return (val !== null) && (val !== undefined) && (val !== "")
                ? true
                : Ext.locale.translate('This field is mandatory');
        };
    },

    getFieldName: function() {
        return this.items.items[1].items.items[0].getName();
    },

    getFieldCombo: function() {
        return this.items.items[1].items.items[0];
    },

    setFieldEnable: function() {
        this.items.items[1].items.items[0].enable();
    },

    setFieldDisable: function() {
        this.items.items[1].items.items[0].disable();
    },

    setTooltip: function(text) {
        new Ext.ToolTip({
            target: this.items.items[1].items.items[0].getEl(),
            html: text
        });
    },

    unsetValidate: function() {
        Ext.apply(this.items.items[1].items.items[0], {validator: function(value){
            return true;
        }});
    }

});