/*
 * File: app/view/fields/snmpauth.js
 *
 * This file was generated by Sencha Architect version 4.2.3.
 * http://www.sencha.com/products/architect/
 *
 * This file requires use of the Ext JS 4.2.x library, under independent license.
 * License of Sencha Architect does not include license for Ext JS 4.2.x. For more
 * details see http://www.sencha.com/license or contact license@sencha.com.
 *
 * This file will be auto-generated each and everytime you save your project.
 *
 * Do NOT hand edit this file.
 */

Ext.define('model_wiz.view.fields.snmpauth', {
    extend: 'Ext.form.FieldContainer',
    alias: 'widget.fieldssnmpauth',

    requires: [
        'Ext.form.FieldContainer',
        'Ext.form.field.Display',
        'Ext.form.field.ComboBox',
        'Ext.ProgressBar'
    ],

    margin: '0 0 15',
    width: 450,
    fieldLabel: '',
    labelSeparator: ' ',
    labelWidth: 150,

    layout: {
        type: 'hbox',
        align: 'stretch'
    },

    initComponent: function() {
        var me = this;

        Ext.applyIf(me, {
            items: [
                {
                    xtype: 'fieldcontainer',
                    padding: '0 10 0 0',
                    width: 200,
                    fieldLabel: Ext.locale.translate('SNMP'),
                    labelAlign: 'top',
                    layout: {
                        type: 'vbox',
                        align: 'stretch'
                    },
                    items: [
                        {
                            xtype: 'displayfield',
                            cls: 'field-description',
                            value: Ext.locale.translate('Select or create an authentication to access the host(s)')
                        }
                    ]
                },
                {
                    xtype: 'fieldcontainer',
                    flex: 1,
                    maxWidth: 450,
                    layout: {
                        type: 'vbox',
                        align: 'stretch'
                    },
                    items: [
                        {
                            xtype: 'combobox',
                            inputType: 'snmpauth',
                            margin: '2 0 0',
                            width: 220,
                            fieldLabel: Ext.locale.translate('Select or create an authention to access the host(s)'),
                            hideLabel: true,
                            labelAlign: 'top',
                            labelCls: 'x-form-item-label fiel-description',
                            labelSeparator: ' ',
                            labelWidth: 150,
                            autoSelect: false,
                            displayField: 'snmp_name',
                            forceSelection: true,
                            queryMode: 'local',
                            store: 'snmpauth_store',
                            valueField: 'snmp_community_id',
                            listeners: {
                                select: {
                                    fn: me.onComboboxSelect,
                                    scope: me
                                },
                                change: {
                                    fn: me.Change,
                                    scope: me
                                },
                                boxready: {
                                    fn: me.onComboboxBoxReady,
                                    scope: me
                                }
                            }
                        },
                        {
                            xtype: 'progressbar',
                            height: 2,
                            hidden: true,
                            value: 0.4
                        },
                        {
                            xtype: 'displayfield',
                            flex: 1,
                            cls: 'field-description',
                            hidden: true,
                            value: Ext.locale.translate('return')
                        }
                    ]
                }
            ]
        });

        me.callParent(arguments);
    },

    onComboboxSelect: function(combo, records, eOpts) {
        if (combo.getValue() === "__create__new") {
            var communityStore = Authentication.app.getStore("Community");
            var authBox = Ext.create("Authentication.view.Main");
            var authBoxStore = authBox.query("#versionField")[0].getStore();
            var authWindow = Ext.create(model_wiz.view.modal.new_snmp, {
                items: [ authBox ]
            });

            authBoxStore.remove(authBoxStore.data.items.filter(function(x) { return (x.data.field1 === "credentials"); }));

            Authentication.app.getController("Manager.Panel").goToForm();

            Authentication.app.getController("Intention").observer.on("cancel", function() {
                var parent_combo = model_wiz.id_cache;
                Ext.getCmp(parent_combo.id).setValue('');
                authWindow.destroy();
            });

            communityStore.on("load", function() {
                var parent_combo = model_wiz.id_cache;
                var store = parent_combo.getStore();

                store.removeAll();

                store.add({
                    snmp_name	: "[".concat(Ext.locale.translate('Create new')).concat("...]"),
                    snmp_community_id	: "__create__new"
                });

                store.add.apply
                ( store
                 , Authentication.app.getStore("Community").data.items
                 .filter(function(x) { return (x.data.snmp_version !== "credentials"); })
                 .map(function(x) {
                     return (
                         { snmp_community_id: x.data.community_id
                          , snmp_name: x.data.name
                         }
                     );
                 })
                );
            }, communityStore, { single: true });

            Authentication.app.getController("Intention").observer.on("save", function(x) {
                authWindow.destroy();
            });

            authWindow.show();
            model_wiz.id_cache = combo;
            combo.clearValue();
        } else {
            Ext.getStore('selected_hosts_store').data.items.forEach(
                function (host) {
                    host.set('opcfgSnmpCommunityId', combo.getValue());
                }
            );
        }
    },

    Change: function(field, newValue, oldValue, eOpts) {
        this.forward(field,'record');
    },

    onComboboxBoxReady: function(component, width, height, eOpts) {
        Ext.Ajax.request({
            url : '/opmon/seagull/www/index.php/discovery/action/list_communities/',
            success : function(r){
                authStore = component.getStore();
                authStore.removeAll();
                authStore.add({
                    snmp_name: "[".concat(Ext.locale.translate('Create new')).concat("...]"),
                    snmp_version: "__create__new",
                    snmp_community_id: "__create__new"
                });
                var res = Ext.decode(r.responseText, true);

                if (res !== null && typeof (res) !== 'undefined'){
                    Ext.each(res.communities, function(obj){
                        authStore.add({
                            snmp_community_id: obj.community_id,
                            snmp_name: obj.name
                        });
                    });
                }
            },
            failure : function(r){
            }
        });
    },

    forward: function(child,event) {
        var parent_step = this.up('modelstep');
        parent_step.forward(child,event);
    },

    setDescription: function(text) {
        this.items.items[0].items.items[0].setValue(text);
    },

    setFieldLabel: function(text) {
        this.items.items[0].setFieldLabel(text);
    },

    setFieldName: function(name) {
        Ext.apply(this.items.items[1].items.items[0], {name: name});
    },

    setFieldValue: function(value) {
        this.items.items[1].items.items[0].setValue(value);
    },

    setMandatory: function() {
        this.items.items[1].items.items[0].validator = function(val) {
            return (val !== null) && (val !== undefined) && (val !== "")
                ? true
                : Ext.locale.translate('This field is mandatory');
        };
    },

    getFieldValue: function() {
        return this.items.items[1].items.items[0].getValue();
    },

    getFieldName: function() {
        return this.items.items[1].items.items[0].getName();
    },

    getFieldCombo: function() {
        return this.items.items[1].items.items[0];
    }

});