/*
 * File: app/view/host/result.js
 *
 * This file was generated by Sencha Architect version 4.2.3.
 * http://www.sencha.com/products/architect/
 *
 * This file requires use of the Ext JS 4.2.x library, under independent license.
 * License of Sencha Architect does not include license for Ext JS 4.2.x. For more
 * details see http://www.sencha.com/license or contact license@sencha.com.
 *
 * This file will be auto-generated each and everytime you save your project.
 *
 * Do NOT hand edit this file.
 */

Ext.define('model_wiz.view.host.result', {
    extend: 'Ext.panel.Panel',
    alias: 'widget.hostresult',

    requires: [
        'Ext.grid.Panel',
        'Ext.grid.column.Column',
        'Ext.grid.View',
        'Ext.selection.CheckboxModel',
        'Ext.form.Panel',
        'Ext.form.field.Checkbox',
        'Ext.form.FieldContainer',
        'Ext.form.FieldSet',
        'Ext.form.field.ComboBox',
        'Ext.form.field.Number'
    ],

    bodyCls: 'grey-light-bg',
    collapsed: false,
    collapsible: false,
    title: Ext.locale.translate('host'),

    layout: {
        type: 'hbox',
        align: 'stretch'
    },

    initComponent: function() {
        var me = this;

        Ext.applyIf(me, {
            items: [
                {
                    xtype: 'gridpanel',
                    flex: 1,
                    margin: '14 9 14 12',
                    title: Ext.locale.translate('Hosts'),
                    store: 'overview_store',
                    columns: [
                        {
                            xtype: 'gridcolumn',
                            dataIndex: 'address',
                            text: Ext.locale.translate('Address'),
                            tooltip: Ext.locale.translate('Address'),
                            flex: 1
                        },
                        {
                            xtype: 'gridcolumn',
                            dataIndex: 'name',
                            text: Ext.locale.translate('Hostname'),
                            tooltip: Ext.locale.translate('Hostname'),
                            flex: 1
                        }
                    ],
                    viewConfig: {
                        itemId: 'hostGridView',
                        emptyText: Ext.locale.translate('No has any service')
                    },
                    selModel: Ext.create('Ext.selection.CheckboxModel', {
                        checkOnly: true,
                        listeners: {
                            beforeselect: {
                                fn: me.onCheckboxModelBeforeSelect,
                                scope: me
                            },
                            beforedeselect: {
                                fn: me.onCheckboxModelBeforeDeselect,
                                scope: me
                            },
                            select: {
                                fn: me.onCheckboxModelSelect,
                                scope: me
                            },
                            deselect: {
                                fn: me.onCheckboxModelDeselect,
                                scope: me
                            }
                        }
                    })
                },
                {
                    xtype: 'form',
                    itemId: 'settings_form2',
                    margin: '14 12 14 9',
                    width: 550,
                    bodyPadding: 10,
                    title: Ext.locale.translate('Settings'),
                    items: [
                        {
                            xtype: 'checkboxfield',
                            itemId: 'overwrite_chkbox',
                            margin: '0 0 10 0',
                            fieldLabel: '',
                            boxLabel: Ext.locale.translate('Overwrite current hosts settings'),
                            checked: true,
                            listeners: {
                                change: {
                                    fn: me.onOverwrite_chkboxChange11,
                                    scope: me
                                }
                            }
                        },
                        {
                            xtype: 'fieldcontainer',
                            margin: '0 0 10 0',
                            fieldLabel: '',
                            layout: {
                                type: 'hbox',
                                align: 'stretch'
                            },
                            items: [
                                {
                                    xtype: 'fieldset',
                                    flex: 3,
                                    margin: '0 8 0 0 ',
                                    checkboxName: 'check_fields',
                                    title: Ext.locale.translate('Checks'),
                                    items: [
                                        {
                                            xtype: 'combobox',
                                            anchor: '100%',
                                            fieldLabel: Ext.locale.translate('Period'),
                                            labelWidth: 110,
                                            name: 'check_period',
                                            value: '1',
                                            displayField: 'timeperiod_name',
                                            queryMode: 'local',
                                            store: 'timeperiod_store',
                                            valueField: 'timeperiod_id'
                                        },
                                        {
                                            xtype: 'numberfield',
                                            anchor: '100%',
                                            fieldLabel: Ext.locale.translate('Interval'),
                                            labelWidth: 110,
                                            name: 'normal_check_interval',
                                            value: 5
                                        },
                                        {
                                            xtype: 'numberfield',
                                            anchor: '100%',
                                            fieldLabel: Ext.locale.translate('Retry interval'),
                                            labelWidth: 110,
                                            name: 'retry_check_interval',
                                            value: 3
                                        },
                                        {
                                            xtype: 'numberfield',
                                            anchor: '100%',
                                            fieldLabel: Ext.locale.translate('Maximum Check Attempts'),
                                            labelWidth: 110,
                                            name: 'max_check_attempts',
                                            value: 3
                                        }
                                    ]
                                },
                                {
                                    xtype: 'fieldset',
                                    flex: 2,
                                    margin: '0 0 0 8',
                                    checkboxName: 'notification_fields',
                                    title: Ext.locale.translate('Notifications'),
                                    items: [
                                        {
                                            xtype: 'checkboxfield',
                                            anchor: '100%',
                                            fieldLabel: '',
                                            name: 'notifications_enabled',
                                            boxLabel: Ext.locale.translate('Notifications enabled'),
                                            checked: true
                                        },
                                        {
                                            xtype: 'combobox',
                                            anchor: '100%',
                                            fieldLabel: Ext.locale.translate('Period'),
                                            labelWidth: 60,
                                            name: 'notification_period',
                                            value: '1',
                                            displayField: 'timeperiod_name',
                                            queryMode: 'local',
                                            store: 'timeperiod_store',
                                            valueField: 'timeperiod_id'
                                        },
                                        {
                                            xtype: 'numberfield',
                                            anchor: '100%',
                                            fieldLabel: Ext.locale.translate('Interval'),
                                            labelWidth: 60,
                                            name: 'notification_interval',
                                            value: 0
                                        }
                                    ]
                                }
                            ]
                        },
                        {
                            xtype: 'fieldcontainer',
                            fieldLabel: '',
                            layout: {
                                type: 'hbox',
                                align: 'stretch'
                            },
                            items: [
                                {
                                    xtype: 'fieldset',
                                    flex: 1,
                                    margin: '0 8 0 0 ',
                                    title: Ext.locale.translate('Contactgroups and Contacts'),
                                    items: [
                                        {
                                            xtype: 'boxselect',
                                            anchor: '100%',
                                            itemId: 'contactGroup',
                                            fieldLabel: '',
                                            labelWidth: 130,
                                            name: 'contactGroups',
                                            emptyText: Ext.locale.translate('Select a contactgroup'),
                                            displayField: 'contactgroup_name',
                                            multiSelect: true,
                                            queryMode: 'local',
                                            store: 'contactgroups_store',
                                            valueField: 'contactgroup_id'
                                        },
                                        {
                                            xtype: 'boxselect',
                                            anchor: '100%',
                                            fieldLabel: '',
                                            labelWidth: 130,
                                            name: 'contacts',
                                            emptyText: Ext.locale.translate('Select a contacts'),
                                            displayField: 'contact_name',
                                            multiSelect: true,
                                            queryMode: 'local',
                                            store: 'contacts_store',
                                            valueField: 'contact_id'
                                        }
                                    ]
                                },
                                {
                                    xtype: 'fieldset',
                                    flex: 1,
                                    margin: '0 0 0 8',
                                    title: Ext.locale.translate('Hostgroup'),
                                    items: [
                                        {
                                            xtype: 'boxselect',
                                            anchor: '100%',
                                            fieldLabel: '',
                                            labelWidth: 130,
                                            name: 'hostGroups',
                                            emptyText: Ext.locale.translate('Select a hostgroup'),
                                            displayField: 'hostgroup_name',
                                            multiSelect: true,
                                            queryMode: 'local',
                                            store: 'hostgroup_store',
                                            valueField: 'hostgroup_id'
                                        }
                                    ]
                                }
                            ]
                        }
                    ]
                }
            ]
        });

        me.callParent(arguments);
    },

    onCheckboxModelBeforeSelect: function(rowmodel, record, index, eOpts) {
        var result = Ext.getStore('license').selectData('hosts', record);
        return ! result.error;
    },

    onCheckboxModelBeforeDeselect: function(rowmodel, record, index, eOpts) {
        return Ext.getStore('license').deselectData('hosts', record);
    },

    onCheckboxModelSelect: function(rowmodel, record, index, eOpts) {
        model_wiz.app.getController('steps.nav.Overview').updateLicenseCmp('hosts');
        model_wiz.app.getController('steps.nav.Overview').updateLicenseCmp('services');

        model_wiz.app.getController('steps.nav.Overview').updateAccordionHeader('hosts', Ext.getCmp('hosts_created').down());
        model_wiz.app.getController('steps.nav.Overview').updateAccordionHeader('hostsExisting', Ext.getCmp('hosts_modified').down());
        model_wiz.app.getController('steps.nav.Overview').updateAccordionHeader('services', Ext.getCmp('services_created').down());
        model_wiz.app.getController('steps.nav.Overview').updateAccordionHeader('servicesExisting', Ext.getCmp('services_conflict').down());
    },

    onCheckboxModelDeselect: function(rowmodel, record, index, eOpts) {
        model_wiz.app.getController('steps.nav.Overview').updateLicenseCmp('hosts');
        model_wiz.app.getController('steps.nav.Overview').updateLicenseCmp('services');

        model_wiz.app.getController('steps.nav.Overview').updateAccordionHeader('hosts', Ext.getCmp('hosts_created').down());
        model_wiz.app.getController('steps.nav.Overview').updateAccordionHeader('hostsExisting', Ext.getCmp('hosts_modified').down());
        model_wiz.app.getController('steps.nav.Overview').updateAccordionHeader('services', Ext.getCmp('services_created').down());
        model_wiz.app.getController('steps.nav.Overview').updateAccordionHeader('servicesExisting', Ext.getCmp('services_conflict').down());
    },

    onOverwrite_chkboxChange11: function(field, newValue, oldValue, eOpts) {
        Ext.ComponentQuery.query('#hosts_modified #settings_form fieldcontainer')
            .forEach(function(c) {
                c.setDisabled(! newValue);
            });
    }

});