/*
 * File: app/view/modal/new_host.js
 *
 * This file was generated by Sencha Architect version 4.2.3.
 * http://www.sencha.com/products/architect/
 *
 * This file requires use of the Ext JS 4.2.x library, under independent license.
 * License of Sencha Architect does not include license for Ext JS 4.2.x. For more
 * details see http://www.sencha.com/license or contact license@sencha.com.
 *
 * This file will be auto-generated each and everytime you save your project.
 *
 * Do NOT hand edit this file.
 */

Ext.define('model_wiz.view.modal.new_host', {
    extend: 'Ext.window.Window',
    alias: 'widget.modalnew_host',

    requires: [
        'Ext.form.Panel',
        'Ext.form.field.TextArea',
        'Ext.form.field.Hidden',
        'Ext.toolbar.Toolbar',
        'Ext.toolbar.Spacer',
        'Ext.button.Button'
    ],

    height: 260,
    id: 'modal_new_host',
    width: 420,
    overflowY: 'auto',
    layout: 'card',
    bodyPadding: 0,
    title: Ext.locale.translate('Add new host manually'),
    modal: true,

    initComponent: function() {
        var me = this;

        Ext.applyIf(me, {
            items: [
                {
                    xtype: 'form',
                    height: 120,
                    id: 'new_host_form',
                    width: 400,
                    bodyPadding: 13,
                    items: [
                        {
                            xtype: 'textfield',
                            anchor: '100%',
                            fieldLabel: Ext.locale.translate('Address'),
                            inputId: 'address',
                            allowBlank: false,
                            listeners: {
                                afterrender: {
                                    fn: me.afterRenderSetFocus,
                                    delay: 2,
                                    scope: me
                                },
                                blur: {
                                    fn: me.onTextfieldBlur,
                                    scope: me
                                }
                            }
                        },
                        {
                            xtype: 'textfield',
                            validator: function(value) {

                                if (value) {
                                    var store = Ext.getStore('hosts');
                                    var hostStoreExists = (store.findExact('host_name', value) !== -1);

                                    var hostExists = false;
                                    var params = {
                                        hostname: value
                                    };

                                    Ext.Ajax.request({
                                        url : '/opmon/seagull/www/index.php/models/action/host_already_exists/',
                                        params: params,
                                        success : function(r){
                                            var res = Ext.decode(r.responseText, true);
                                            if (res !== null && typeof (res) !== 'undefined'){
                                                hostExists = res.data;
                                            }
                                        },
                                        failure : function(r){
                                            return 'check hostname already exists has failed';
                                        }
                                    });

                                    if ((hostStoreExists) || (hostExists)) {
                                        return 'A host with that name already exists!';
                                    }

                                    return true;
                                }

                                return true;
                            },
                            anchor: '100%',
                            fieldLabel: Ext.locale.translate('Hostname'),
                            validateOnChange: false,
                            inputId: 'host_name',
                            allowBlank: false,
                            allowOnlyWhitespace: false,
                            listeners: {
                                blur: {
                                    fn: me.onTextfieldBlur1,
                                    scope: me
                                }
                            }
                        },
                        {
                            xtype: 'textareafield',
                            anchor: '100%',
                            height: 105,
                            fieldLabel: Ext.locale.translate('Description'),
                            inputId: 'alias',
                            allowBlank: false,
                            allowOnlyWhitespace: false
                        },
                        {
                            xtype: 'hiddenfield',
                            anchor: '100%',
                            fieldLabel: 'Label',
                            value: 2,
                            inputId: 'state'
                        }
                    ],
                    dockedItems: [
                        {
                            xtype: 'toolbar',
                            dock: 'bottom',
                            items: [
                                {
                                    xtype: 'tbspacer',
                                    flex: 1
                                },
                                {
                                    xtype: 'button',
                                    handler: function(button, e) {
                                        Ext.getCmp('modal_new_host').layout.setActiveItem('add_multiple_host_form');
                                    },
                                    tabIndex: 1,
                                    text: Ext.locale.translate('Add more than one')
                                },
                                {
                                    xtype: 'container',
                                    items: [
                                        {
                                            xtype: 'button',
                                            handler: function(button, e) {
                                                var form = Ext.getCmp('new_host_form');

                                                if (form.isValid()) {
                                                    var position = Ext.getStore('hosts').add(form.getValues());

                                                    Ext.getCmp('modal_new_host').destroy();

                                                    Ext.getCmp('host_list').selModel.doSelect(position, true);
                                                    Ext.getCmp('host_list').updateLayout();
                                                }

                                                else {
                                                    var target = this.getXY();
                                                    var errors = form.items.items
                                                    .reduce(function(acc, x) { return x.isValid() ? acc : acc.concat(x.name); }, [])
                                                    .join(", ");

                                                    var tooltip = new Ext.ToolTip({
                                                        targetXY: [target[0] + this.getWidth() - 10, target[1] - (this.getHeight() / 2)],
                                                        html: "Inputs ".concat(errors).concat(" is invalid.")
                                                    });
                                                    tooltip.show();
                                                    setTimeout(function() { tooltip.destroy(); }, 3000);
                                                }
                                            },
                                            iconCls: 'fa fa-check icon-white',
                                            text: Ext.locale.translate('Create new host')
                                        }
                                    ]
                                }
                            ]
                        }
                    ]
                },
                {
                    xtype: 'form',
                    id: 'add_multiple_host_form',
                    bodyPadding: 13,
                    header: false,
                    title: 'My Form',
                    layout: {
                        type: 'vbox',
                        align: 'stretch'
                    },
                    items: [
                        {
                            xtype: 'textareafield',
                            validator: function(value) {
                                Ext.getCmp("create-new-hosts").disable();
                                var hosts = value.split(/\r\n|\r|\n/g);

                                for(var i = 0; i < hosts.length; i++) {
                                    if (! hosts[i].split(',')) {
                                        return "There is a blank line";
                                    }
                                    var columns = hosts[i].split(',');
                                    if (columns.length !== 3) {
                                        return Ext.locale.translate('Syntax error on line:') + " " + hosts[i] + ". " + Ext.locale.translate('Correct Syntax: hostname,adddress,description');
                                    }
                                    for(var c = 0; c < columns.length; c++) {
                                        if (! columns[c]) {
                                            return "On line: "+hosts[i]+". Missing values";
                                        }
                                    }
                                }
                                Ext.getCmp("create-new-hosts").enable();
                                return true;
                            },
                            flex: 1,
                            maxHeight: 130,
                            fieldLabel: Ext.locale.translate('Add multiple hosts. Write as follow: ip,hostname,description. Write one host per line.'),
                            labelAlign: 'top',
                            name: 'multiple_hosts',
                            inputId: 'multiple_hosts',
                            allowBlank: false,
                            emptyText: Ext.locale.translate('Example: 192.168.10.1,linux server 07,intranet and website server.')
                        }
                    ],
                    dockedItems: [
                        {
                            xtype: 'toolbar',
                            dock: 'bottom',
                            items: [
                                {
                                    xtype: 'tbspacer',
                                    flex: 1
                                },
                                {
                                    xtype: 'button',
                                    handler: function(button, e) {
                                        Ext.getCmp('modal_new_host').layout.setActiveItem('new_host_form');
                                    },
                                    tabIndex: 1,
                                    text: Ext.locale.translate('Add just one')
                                },
                                {
                                    xtype: 'container',
                                    items: [
                                        {
                                            xtype: 'button',
                                            handler: function(button, e) {
                                                var form = Ext.getCmp('add_multiple_host_form');
                                                if (form.isValid()) {

                                                    var form_values = form.getValues();
                                                    form_values = form_values.multiple_hosts;
                                                    form_array = form_values.split(/\r\n|\r|\n/g);
                                                    for(var i = 0; i < form_array.length; i++) {
                                                        var received_values = form_array[i].split(',');
                                                        var new_host = { address: received_values[0], host_name: received_values[1], alias: received_values[2] };
                                                        Ext.getStore('hosts').add(new_host);
                                                        var position = Ext.getCmp('host_list').store.data.items.length - 1;
                                                        position = Ext.getCmp('host_list').store.data.items[position];
                                                        Ext.getCmp('host_list').selModel.doSelect(position, true);
                                                    }

                                                    Ext.getCmp('modal_new_host').destroy();
                                                }
                                            },
                                            disabled: true,
                                            id: 'create-new-hosts',
                                            iconCls: 'fa fa-check icon-white',
                                            text: Ext.locale.translate('Create new hosts')
                                        }
                                    ]
                                }
                            ]
                        }
                    ]
                }
            ]
        });

        me.callParent(arguments);
    },

    afterRenderSetFocus: function(component, eOpts) {
        component.focus();
    },

    onTextfieldBlur: function(component, e, eOpts) {
        component.setValue(changeCharCode(component.getValue()));
    },

    onTextfieldBlur1: function(component, e, eOpts) {
        component.setValue(changeCharCode(component.getValue()));
        return false;
    }

});