/*
 * File: app/view/model/panel.js
 *
 * This file was generated by Sencha Architect version 4.2.3.
 * http://www.sencha.com/products/architect/
 *
 * This file requires use of the Ext JS 4.2.x library, under independent license.
 * License of Sencha Architect does not include license for Ext JS 4.2.x. For more
 * details see http://www.sencha.com/license or contact license@sencha.com.
 *
 * This file will be auto-generated each and everytime you save your project.
 *
 * Do NOT hand edit this file.
 */

Ext.define('model_wiz.view.model.panel', {
    extend: 'Ext.panel.Panel',
    alias: 'widget.modelpanel',

    requires: [
        'Ext.form.Panel',
        'Ext.tab.Panel',
        'Ext.tab.Bar',
        'Ext.toolbar.Toolbar',
        'Ext.button.Button'
    ],

    hosts: '[]',
    beingedited: '',
    cls: 'header_setup_params',
    hideCollapseTool: true,
    title: Ext.locale.translate('Model Name'),

    layout: {
        type: 'hbox',
        align: 'stretch'
    },

    initComponent: function() {
        var me = this;

        Ext.applyIf(me, {
            items: [
                {
                    xtype: 'form',
                    flex: 1,
                    id: 'paramsForm',
                    padding: '8 0 0 0',
                    layout: {
                        type: 'vbox',
                        align: 'stretch'
                    },
                    items: [
                        {
                            xtype: 'tabpanel',
                            height: 36,
                            hidden: true,
                            id: 'selected_hosts_tab',
                            margin: '0 6',
                            maxHeight: 36,
                            activeTab: 0,
                            plain: true,
                            tabBar: {
                                xtype: 'tabbar'
                            },
                            listeners: {
                                beforeshow: {
                                    fn: me.onTabpanelBeforeShow1,
                                    scope: me
                                },
                                hide: {
                                    fn: me.onTabpanelHide1,
                                    scope: me
                                },
                                tabchange: {
                                    fn: me.onSelected_hosts_tabTabChange,
                                    scope: me
                                }
                            }
                        },
                        {
                            xtype: 'tabpanel',
                            cls: 'opsubpanel',
                            id: 'modelstepstabbar',
                            margin: '0 0 0 6',
                            header: false,
                            headerPosition: 'right',
                            title: 'model steps',
                            titleAlign: 'right',
                            titleCollapse: false,
                            activeTab: 0,
                            plain: true,
                            tabBar: {
                                xtype: 'tabbarmodelsteps',
                                id: 'tabbarmodelsteps',
                                margin: '0 10 0 0',
                                plain: true,
                                listeners: {
                                    change: {
                                        fn: me.onTabbarChange,
                                        scope: me
                                    }
                                }
                            },
                            listeners: {
                                boxready: {
                                    fn: me.onStep_03_contentBoxReady,
                                    scope: me
                                }
                            }
                        }
                    ]
                },
                {
                    xtype: 'toolbar',
                    hidden: true,
                    padding: '6 0 6 6 ',
                    items: [
                        {
                            xtype: 'button',
                            text: 'Configure one by one',
                            listeners: {
                                click: {
                                    fn: me.onButtonClick,
                                    scope: me
                                }
                            }
                        },
                        {
                            xtype: 'button',
                            text: 'Configure all',
                            listeners: {
                                click: {
                                    fn: me.onButtonClick1,
                                    scope: me
                                }
                            }
                        }
                    ]
                }
            ]
        });

        me.callParent(arguments);
    },

    onTabpanelBeforeShow1: function(component, eOpts) {
        var selected_hosts = Ext.getStore('selected_hosts_store');
        var hosts = selected_hosts.data.items;

        for (var i = 0; i < hosts.length; i++) {
            var new_panel = Ext.create('Ext.panel.Panel', {
                title: hosts[i].data.host_name,
                width: 200,
                host_id: hosts[i].data.host_id
            });
            component.add(new_panel);
        }
        component.setActiveTab(0);
    },

    onTabpanelHide1: function(component, eOpts) {
        component.removeAll();
    },

    onSelected_hosts_tabTabChange: function(tabPanel, newCard, oldCard, eOpts) {
        var me = this;
        var tabActiveStore = Ext.getStore('tab_active_host');
        var tabHost = {host_id: newCard.host_id};
        tabActiveStore.removeAll();
        tabActiveStore.add(tabHost);
        var host_id = tabActiveStore.getAt(0).get("host_id");
        var tabActiveServiceStore = Ext.getStore('tab_active_service');
        var service_name = tabActiveServiceStore.getAt(0).get("service_name");
        var hostStore = Ext.getStore('selected_hosts_store');
        var host = hostStore.findRecord("host_id", host_id);
        //var globalparams = host.data.globalparams;
        //var services = host.data.services;
        var tabItems = Ext.ComponentQuery.query("modelstep[tabName="+service_name+"]");

        Ext.iterate(tabItems, function(tab){
            for (var i in tab.items.items) {
                var field = tab.items.items[i];
                me.retrieveFieldsProperties(host, field, service_name);
            }
        });
    },

    onTabbarChange: function(tabBar, tab, card, eOpts) {
        tab.addCls("tab-done");

        var me = this;
        var tabActiveServiceStore = Ext.getStore('tab_active_service');
        var tabService = {service_name: card.tabName};
        tabActiveServiceStore.removeAll();
        tabActiveServiceStore.add(tabService);
        var service_name = tabActiveServiceStore.getAt(0).get("service_name");

        var tabActiveHostStore = Ext.getStore('tab_active_host');
        var count = tabActiveHostStore.getCount();
        var host_id = false;
        if (count > 0) {
            host_id = tabActiveHostStore.getAt(0).get("host_id");
        }

        var hostStore = Ext.getStore('selected_hosts_store');

        var tabItems = Ext.ComponentQuery.query("modelstep[tabName="+service_name+"]");
        Ext.iterate(tabItems, function(tab){
            for (var i in tab.items.items) {
                var field = tab.items.items[i];
                if (host_id !== false) {
                    var host = hostStore.findRecord("host_id", host_id);
                    me.retrieveFieldsProperties(host, field, service_name);
                } else {
                    hostStore.each(function(host){
                        me.retrieveFieldsProperties(host, field, service_name);
                    });
                }
            }
        });
    },

    onStep_03_contentBoxReady: function(component, width, height, eOpts) {
        var me = this;
        activeTab = Ext.getCmp(component.tabBar.activeTab);
        if (activeTab !== undefined) {
        //    console.log(component.tabBar.items.items[0]);
        //    me.checkGlobalFields(component.tabBar.items.items[0]);
        //} else {
            Ext.getCmp(component.tabBar.activeTab.id).addCls("tab-done");
        }
        var tabs = component.tabBar.items.items;
        for (var i = 0; i < tabs.length; i++) {
            var el  = tabs[i].id;
            Ext.getCmp(el).addCls("tab-for-all");
        }
    },

    onButtonClick: function(button, e, eOpts) {
        Ext.getCmp("selected_hosts_tab").show();
    },

    onButtonClick1: function(button, e, eOpts) {
        Ext.getCmp("selected_hosts_tab").hide();
        var tabActiveStore = Ext.getStore('tab_active_host');
        var count = tabActiveStore.getCount();
        if (count === 0) {
            return;
        }

        tabActiveStore.removeAll();

        Ext.each(Ext.getCmp("paramsForm").getForm().getFields().items, function(field){
            if (field.xtype !== "displayfield") {
                field.setValue('');
            }
        });
        var hostStore = Ext.getStore('selected_hosts_store');
        hostStore.each(function(host){
            for (var i in host.data.globalparams) {
                host.data.globalparams[i].value = "";
            }
        });
    },

    forward: function(child,event) {
        if (! Ext.getCmp('modelstepstabbar').getActiveTab()) {
            return false;
        }

        if (Ext.getCmp('modelstepstabbar').getActiveTab().id !== child.up("modelstep").id) {
            return false;
        }

        var me = this;
        model_wiz.app.getController('Navbar').triggerStep('setup_parameters', [], 'validate_form');

        var tabActiveHostStore = Ext.getStore('tab_active_host');
        var count = tabActiveHostStore.getCount();
        var host_id = false;
        if (count > 0) {
            host_id = tabActiveHostStore.getAt(0).get("host_id");
        }

        var tabActiveServiceStore = Ext.getStore('tab_active_service');
        var count = tabActiveServiceStore.getCount();
        var service_name = tabActiveServiceStore.getAt(0).get("service_name");
        var hostStore = Ext.getStore('selected_hosts_store');
        var fieldType = child.up("fields" + child.inputType);

        if (host_id !== false) {
            var host = hostStore.findRecord("host_id", host_id);
            me.setFieldsProperties(host, fieldType, service_name);
        } else {
            hostStore.each(function(host){
                me.setFieldsProperties(host, fieldType, service_name);
            });
        }
    },

    setFieldsProperties: function(host, field, service_name) {
        var me = this;

        if (field.globalField === true) {
            host.data.globalparams[field.getFieldName()].value = field.getFieldValue();
            me.checkActionGlobalFields(host, service_name);
        }

        if (field.localField === true) {
            var service = host.data.services[service_name];
            service.localparams[field.getFieldName()].value = field.getFieldValue();
            host.data.services[service_name] = service;
            me.checkActionLocalFields(host, service_name);
        }
    },

    retrieveFieldsProperties: function(host, field, service_name) {
        var me = this;
        var T = model_wiz.helpers.Utils;

        if (! Ext.getCmp('modelstepstabbar').getActiveTab()) {
            return false;
        }

        var globalparams = host.data.globalparams;
        if (field.globalField === true) {
            if (field.inputType === "hostaddress") {
                host.data.globalparams[field.getFieldName()].value = host.data.address;

                var address = Ext.getStore('selected_hosts_store').data.items
                    .map(function(host) {
                        return host.get('address');
                    })
                    .reduce(function(acc, address) {
                        return (acc.some(function(x) { return x === address; }))
                            ? acc
                            : acc.concat(address);
                    }, [])
                    .join(', ');

                field.setFieldValue(address);
            }
            if (globalparams[field.getFieldName()].hasOwnProperty('default')) {
                if (host.data.globalparams[field.getFieldName()].default) {
                    host.data.globalparams[field.getFieldName()].value = host.data.globalparams[field.getFieldName()].default;
                }
            }

            if (field.inputType !== "hostaddress") {
                field.setFieldValue(host.data.globalparams[field.getFieldName()].value);
            }

            if (T.isPropertyTrue('createHost', field.data)) {
                var values = model_wiz.app.getController('steps.card.Fields').getSelectedHosts().data.items.map(function(host) {
                    return host.get("globalparams")[field.getFieldName()].value;
                });
                field.setFieldValue(values);
            }
        }

        if (field.localField === true) {
            var service = host.data.services[service_name.toLowerCase()];
            var localparam = service.localparams[field.getFieldName().toLowerCase()];
            if (field.inputType === "multiple" || field.inputType === "select") {
                if (localparam.data.hasOwnProperty("action") && localparam.dependency === null) {
                    me.callLocalParameterDataAction(globalparams, localparam, field);
                }
                if (localparam.data.hasOwnProperty("store")) {
                    me.callDataStore(localparam, field);
                }
            }
            if (localparam.hasOwnProperty('default')) {
                if (! localparam.value || localparam.value === "") {
                    localparam.value = localparam.default;
                }
            }
            field.setFieldValue(localparam.value);
            if (T.isPropertyTrue('createService', field.data)) {
                model_wiz.helpers.Stream.publish('fieldThatCreatesServices', field.getFieldCombo(), field.getFieldCombo().name.toLowerCase(), model_wiz.app.getController('steps.card.Fields'));
            }
        }
    },

    checkGlobalFields: function(activeTab) {
        Ext.getCmp("next_btn").setDisabled(!activeTab.form.isValid());
    },

    checkActionLocalFields: function(host, service_name) {
        var me = this;
        var globalparams = host.data.globalparams;
        var tabItems = Ext.ComponentQuery.query("modelstep[tabName="+service_name+"]");
        Ext.iterate(tabItems, function(tab){
            for (var i in tab.items.items) {
                var field = tab.items.items[i];
                if (! field.hasOwnProperty("inputType")) {
                    continue;
                }
                var service = host.data.services[service_name];
                var localparam = service.localparams[field.getFieldName()];
                if (field.inputType === "multiple" || field.inputType === "select") {
                    if (localparam.dependency !== null) {
                        field.setTooltip("This field depends on the form values");
                        me.callLocalParameterDataAction(globalparams, localparam, field, service.localparams[localparam.dependency]);
                    }
                }
                if (localparam.mandatory === false) {
                    field.unsetValidate();
                }
            }
        });
    },

    checkActionGlobalFields: function(host, service_name) {
        var me = this;
        var globalparams = host.data.globalparams;
        var tabItems = Ext.ComponentQuery.query("modelstep[tabName="+service_name+"]");

        clearTimeout(this.timer);
        this.timer = setTimeout(function(){
            Ext.iterate(tabItems, function(tab){
            for (var i in tab.items.items) {
                var field = tab.items.items[i];
                if (! field.hasOwnProperty("inputType")) {
                    continue;
                }
                if (field.inputType === "multiple" || field.inputType === "select") {
                    var globalparam = globalparams[field.getFieldName()];
                    if (globalparam.dependency instanceof Array) {
                        var dependency_count = 0;
                        var dependency_total = globalparam.dependency.length;
                        for (var param in globalparam.dependency) {
                            var fieldname = globalparam.dependency[param];
                            if (Array.isArray(globalparams[fieldname].value)) {
                                if (globalparams[fieldname].value.length > 0) {
                                    dependency_count++;
                                }
                            } else {
                                if (globalparams[fieldname].value) {
                                    dependency_count++;
                                }
                            }
                        }
                        if (dependency_total === dependency_count) {
                            me.callGlobalParameterDataAction(globalparams, globalparam, field);
                        }
                    }
                    if (globalparam.mandatory === false) {
                        field.unsetValidate();
                    }
                }
            }
        });
        },1000);


    },

    callLocalParameterDataAction: function(globalparams, localparam, field, dependency) {
        // console.log("callLocalParameterDataAction");
        // var selectedModelStore = Ext.getStore("selected_models_store");
        // var model = selectedModelStore.getAt(0).get("name");
        // var manager = selectedModelStore.getAt(0).get("manager");
        // var method = localparam.data.action;
        // var param = {};

        // for (var g in globalparams) {
        //     param[g] = globalparams[g].value;
        // }

        // if (typeof dependency === 'object' && dependency !== null) {
        //     param[dependency.name] = dependency.value;
        // }

        // var params = {
        //     model: model,
        //     manager: manager,
        //     method: method,
        //     param: Ext.JSON.encode(param)
        // };

        // var comboStore = field.getFieldCombo().getStore();
        // comboStore.removeAll();

        // var result = {};
        // comboStore.load({
        //     params: params,
        //     callback: function(records, operation, success) {
        //         if (records.length > 0) {
        //             Ext.iterate(records, function(rec){
        //                 result[rec.data.value] = rec.data.key;
        //             });
        //             field.setFieldEnable();
        //         } else {
        //             field.setTooltip("'+Ext.locale.translate('For the selected elements no ')+' "+field.getFieldName());
        //         }
        //     }
        // });

        // localparam.data.result = result;
    },

    callGlobalParameterDataAction: function(globalparams, globalparam, field) {
        // console.log("callGlobalParameterDataAction");
        // var selectedModelStore = Ext.getStore("selected_models_store");
        // var model = selectedModelStore.getAt(0).get("name");
        // var manager = selectedModelStore.getAt(0).get("manager");
        // var method = globalparam.data.action;
        // var param = {};

        // for (var g in globalparams) {
        //     param[g] = globalparams[g].value;
        // }

        // var params = {
        //     model: model,
        //     manager: manager,
        //     method: method,
        //     param: Ext.JSON.encode(param)
        // };

        // var comboStore = field.getFieldCombo().getStore();
        // comboStore.removeAll();

        // var result = {};
        // comboStore.load({
        //     params: params,
        //     callback: function(records, operation, success) {
        //         if (Array.isArray(records) && records.length > 0) {
        //             Ext.iterate(records, function(rec){
        //                 result[rec.data.value] = rec.data.key;
        //             });
        //             field.setFieldEnable();
        //         } else {
        //             field.setTooltip("'+Ext.locale.translate('For the selected elements no ')+' "+field.getFieldName());
        //         }
        //     }
        // });

        // globalparam.data.result = result;
    },

    callDataStore: function(localparam, field) {
        var params = localparam.data.store;
        var comboStore = field.getFieldCombo().getStore();
        comboStore.removeAll();
        comboStore.add(params);
        field.getFieldCombo().bindStore(comboStore);
    }

});