/*
 * File: app/view/nav_structure.js
 *
 * This file was generated by Sencha Architect version 4.2.3.
 * http://www.sencha.com/products/architect/
 *
 * This file requires use of the Ext JS 4.2.x library, under independent license.
 * License of Sencha Architect does not include license for Ext JS 4.2.x. For more
 * details see http://www.sencha.com/license or contact license@sencha.com.
 *
 * This file will be auto-generated each and everytime you save your project.
 *
 * Do NOT hand edit this file.
 */

Ext.define('model_wiz.view.nav_structure', {
    extend: 'Ext.container.Container',
    alias: 'widget.nav_structure',

    requires: [
        'model_wiz.view.step_01',
        'model_wiz.view.step_02',
        'model_wiz.view.step_03',
        'model_wiz.view.step_04',
        'Ext.form.field.Display',
        'Ext.toolbar.Toolbar',
        'Ext.button.Button',
        'Ext.toolbar.Spacer',
        'Ext.panel.Panel'
    ],

    id: 'categories_view',
    padding: '0 15',
    style: 'overflow-x: hidden;',

    layout: {
        type: 'vbox',
        align: 'stretch'
    },

    initComponent: function() {
        var me = this;

        Ext.applyIf(me, {
            items: [
                {
                    xtype: 'container',
                    height: 40,
                    margin: '0 0 10 0',
                    layout: {
                        type: 'hbox',
                        align: 'stretch'
                    },
                    items: [
                        {
                            xtype: 'container',
                            hidden: true,
                            html: '<div class="x-panel-header-default cat-icon-mini"></div>',
                            id: 'cat_icon',
                            width: 35
                        },
                        {
                            xtype: 'container',
                            flex: 1,
                            margins: '0 0 0 35',
                            id: 'card_header',
                            layout: 'card',
                            items: [
                                {
                                    xtype: 'container',
                                    id: 'step_01_header',
                                    layout: {
                                        type: 'hbox',
                                        align: 'stretch'
                                    },
                                    items: [
                                        {
                                            xtype: 'container',
                                            flex: 1,
                                            hidden: true,
                                            html: '<h4>name</h4>',
                                            id: 'cat_name',
                                            margin: '-5 0 0 0'
                                        },
                                        {
                                            xtype: 'displayfield',
                                            margin: '-5 0 0 0',
                                            fieldLabel: '',
                                            value: Ext.locale.translate('What do you want to monitoring?'),
                                            fieldCls: 'x-form-display-field title'
                                        },
                                        {
                                            xtype: 'toolbar',
                                            flex: 1,
                                            padding: '2 0 0',
                                            items: [
                                                {
                                                    xtype: 'displayfield',
                                                    cls: 'step-marker',
                                                    fieldLabel: '',
                                                    value: Ext.locale.translate('Step 1 of 4')
                                                }
                                            ]
                                        }
                                    ]
                                },
                                {
                                    xtype: 'container',
                                    id: 'step_02_header',
                                    layout: {
                                        type: 'hbox',
                                        align: 'stretch'
                                    },
                                    items: [
                                        {
                                            xtype: 'displayfield',
                                            margin: '-5 0 0 0',
                                            fieldLabel: '',
                                            value: Ext.locale.translate('Select one or more hosts to apply the model'),
                                            fieldCls: 'x-form-display-field title',
                                            listeners: {
                                                beforerender: {
                                                    fn: me.onDisplayfieldBeforeRender,
                                                    scope: me
                                                }
                                            }
                                        },
                                        {
                                            xtype: 'toolbar',
                                            items: [
                                                {
                                                    xtype: 'container',
                                                    hidden: true,
                                                    items: [
                                                        {
                                                            xtype: 'button',
                                                            handler: function(button, e) {
                                                                model_wiz.helpers.Stream.publish('host_select', button, 'view_all_hosts');
                                                            },
                                                            hidden: true,
                                                            itemId: 'viewAllBtn',
                                                            text: Ext.locale.translate('View all hosts')
                                                        }
                                                    ]
                                                }
                                            ]
                                        },
                                        {
                                            xtype: 'toolbar',
                                            flex: 1,
                                            padding: '2 0 0',
                                            items: [
                                                {
                                                    xtype: 'displayfield',
                                                    cls: 'step-marker',
                                                    fieldLabel: '',
                                                    value: Ext.locale.translate('Step 2 of 4')
                                                },
                                                {
                                                    xtype: 'tbspacer',
                                                    flex: 1
                                                },
                                                {
                                                    xtype: 'displayfield',
                                                    cls: 'bold',
                                                    hidden: true,
                                                    id: 'host_selected_count',
                                                    margin: '0 15 0 0',
                                                    fieldLabel: '',
                                                    value: '0 '+Ext.locale.translate('host(s) selected')+''
                                                }
                                            ]
                                        }
                                    ]
                                },
                                {
                                    xtype: 'container',
                                    id: 'step_03_header',
                                    layout: {
                                        type: 'hbox',
                                        align: 'stretch'
                                    },
                                    items: [
                                        {
                                            xtype: 'displayfield',
                                            margin: '-5 0 0 0',
                                            fieldLabel: '',
                                            value: Ext.locale.translate('Configure model settings'),
                                            fieldCls: 'x-form-display-field title'
                                        },
                                        {
                                            xtype: 'toolbar',
                                            flex: 1,
                                            padding: '2 0 0',
                                            items: [
                                                {
                                                    xtype: 'displayfield',
                                                    cls: 'step-marker',
                                                    fieldLabel: '',
                                                    value: Ext.locale.translate('Step 3 of 4')
                                                },
                                                {
                                                    xtype: 'tbspacer',
                                                    flex: 1
                                                },
                                                {
                                                    xtype: 'displayfield',
                                                    cls: 'bold',
                                                    id: 'host_selected_count_1',
                                                    margin: '0 15 0 0',
                                                    fieldLabel: '',
                                                    value: '0 '+Ext.locale.translate('host(s) selected')+''
                                                }
                                            ]
                                        }
                                    ]
                                },
                                {
                                    xtype: 'container',
                                    id: 'step_04_header',
                                    layout: {
                                        type: 'hbox',
                                        align: 'stretch'
                                    },
                                    items: [
                                        {
                                            xtype: 'displayfield',
                                            margin: '-5 0 0 0',
                                            fieldLabel: '',
                                            value: Ext.locale.translate('Review your configuration'),
                                            fieldCls: 'x-form-display-field title'
                                        },
                                        {
                                            xtype: 'toolbar',
                                            flex: 1,
                                            padding: '2 0 0',
                                            items: [
                                                {
                                                    xtype: 'displayfield',
                                                    cls: 'step-marker',
                                                    fieldLabel: '',
                                                    value: Ext.locale.translate('Step 4 of 4')
                                                }
                                            ]
                                        }
                                    ]
                                }
                            ]
                        },
                        {
                            xtype: 'toolbar',
                            id: 'header_btns',
                            padding: 0,
                            layout: {
                                type: 'hbox',
                                pack: 'end'
                            },
                            items: [
                                {
                                    xtype: 'button',
                                    disabled: true,
                                    id: 'back_btn',
                                    iconCls: 'fa fa-chevron-left icon-half-black',
                                    text: Ext.locale.translate('Back')
                                },
                                {
                                    xtype: 'button',
                                    hidden: true,
                                    id: 'skip_btn',
                                    margin: '0 0 0 30',
                                    text: Ext.locale.translate('Skip')
                                },
                                {
                                    xtype: 'container',
                                    items: [
                                        {
                                            xtype: 'button',
                                            disabled: true,
                                            id: 'next_btn',
                                            iconAlign: 'right',
                                            iconCls: 'fa fa-chevron-right icon-white',
                                            text: Ext.locale.translate('Next')
                                        },
                                        {
                                            xtype: 'button',
                                            disabled: true,
                                            hidden: true,
                                            id: 'finish_btn',
                                            iconAlign: 'right',
                                            iconCls: 'fa fa-check icon-white',
                                            text: Ext.locale.translate('Finish')
                                        }
                                    ]
                                }
                            ]
                        }
                    ]
                },
                {
                    xtype: 'panel',
                    flex: 1,
                    id: 'card_container',
                    style: 'overflow-x: hidden; overflow-y: auto;',
                    layout: 'card',
                    bodyStyle: 'overflow-x: hidden; overflow-y: auto;',
                    items: [
                        {
                            xtype: 'step_01'
                        },
                        {
                            xtype: 'step_02'
                        },
                        {
                            xtype: 'step_03',
                            id: 'step_03'
                        },
                        {
                            xtype: 'step_04',
                            id: 'step_04'
                        }
                    ]
                }
            ]
        });

        me.callParent(arguments);
    },

    onDisplayfieldBeforeRender: function(component, eOpts) {
        component.setValue(Ext.locale.translate('Select one or more hosts to apply the model') + ' ' + Ext.getStore('selected_models_store').data.items[0].data.labelName);
    }

});