/*
 * File: app/view/service/result.js
 *
 * This file was generated by Sencha Architect version 4.2.3.
 * http://www.sencha.com/products/architect/
 *
 * This file requires use of the Ext JS 4.2.x library, under independent license.
 * License of Sencha Architect does not include license for Ext JS 4.2.x. For more
 * details see http://www.sencha.com/license or contact license@sencha.com.
 *
 * This file will be auto-generated each and everytime you save your project.
 *
 * Do NOT hand edit this file.
 */

Ext.define('model_wiz.view.service.result', {
    extend: 'Ext.panel.Panel',
    alias: 'widget.serviceresult',

    requires: [
        'Ext.grid.Panel',
        'Ext.grid.column.Action',
        'Ext.grid.View',
        'Ext.selection.CheckboxModel',
        'Ext.form.Panel',
        'Ext.form.field.Checkbox',
        'Ext.form.FieldContainer',
        'Ext.form.FieldSet',
        'Ext.form.field.ComboBox',
        'Ext.form.field.Number'
    ],

    collapsed: false,
    collapsible: false,
    title: Ext.locale.translate('service'),

    layout: {
        type: 'hbox',
        align: 'stretch'
    },

    initComponent: function() {
        var me = this;

        Ext.applyIf(me, {
            items: [
                {
                    xtype: 'gridpanel',
                    resolveAction: function(rec) {
                        var me = this;
                        var winResolveConflict = Ext.create('widget.components.resolveconflict', {
                            record: rec,
                            callback: function(status) {
                                if(status) {
                                    Ext.getCmp('step_04').filterService(['conflict'], [true]);
                                    Ext.ComponentQuery.query('#services_created')[0].setVisible(true);
                                }
                                this.destroy();
                            }
                        });

                        winResolveConflict.show();
                    },
                    removeAction: function(record) {
                        return Ext.getStore('overview_services_store').remove(record);
                    },
                    flex: 1,
                    margin: '14 9 14 12',
                    title: Ext.locale.translate('Services'),
                    store: 'overview_services_store',
                    columns: [
                        {
                            xtype: 'gridcolumn',
                            dataIndex: 'name',
                            text: Ext.locale.translate('Service description'),
                            tooltip: Ext.locale.translate('Service description'),
                            flex: 1
                        },
                        {
                            xtype: 'gridcolumn',
                            dataIndex: 'hostName',
                            text: Ext.locale.translate('Hostname'),
                            tooltip: Ext.locale.translate('Hostname'),
                            flex: 1
                        },
                        {
                            xtype: 'actioncolumn',
                            itemId: 'action_column',
                            width: 45,
                            items: [
                                {
                                    icon: 'resources/ico-editar.png',
                                    iconCls: 'ico-edit',
                                    tooltip: Ext.locale.translate('Resolve conflict')
                                },
                                {
                                    icon: 'resources/ico-excluir.png',
                                    iconCls: 'ico-right ico-remove',
                                    tooltip: Ext.locale.translate('Do not monitor')
                                }
                            ],
                            listeners: {
                                click: {
                                    fn: me.onAction_columnClick,
                                    scope: me
                                }
                            }
                        }
                    ],
                    viewConfig: {
                        itemId: 'serviceGridView',
                        emptyText: Ext.locale.translate('No has any service')
                    },
                    selModel: Ext.create('Ext.selection.CheckboxModel', {
                        checkOnly: true,
                        listeners: {
                            beforeselect: {
                                fn: me.onCheckboxModelBeforeSelect,
                                scope: me
                            },
                            beforedeselect: {
                                fn: me.onCheckboxModelBeforeDeselect,
                                scope: me
                            },
                            deselect: {
                                fn: me.onCheckboxModelDeselect,
                                scope: me
                            },
                            select: {
                                fn: me.onCheckboxModelSelect,
                                scope: me
                            },
                            selectionchange: {
                                fn: me.onCheckboxModelSelectionChange,
                                scope: me
                            }
                        }
                    })
                },
                {
                    xtype: 'form',
                    itemId: 'settings_form1',
                    margin: '14 12 14 9',
                    width: 550,
                    bodyPadding: 10,
                    title: Ext.locale.translate('Settings'),
                    items: [
                        {
                            xtype: 'checkboxfield',
                            itemId: 'overwrite_chkbox',
                            margin: '0 0 10 0',
                            fieldLabel: '',
                            boxLabel: Ext.locale.translate('Overwrite current hosts settings'),
                            checked: true,
                            listeners: {
                                change: {
                                    fn: me.onOverwrite_chkboxChange1,
                                    scope: me
                                }
                            }
                        },
                        {
                            xtype: 'fieldcontainer',
                            margin: '0 0 10 0',
                            fieldLabel: '',
                            layout: {
                                type: 'hbox',
                                align: 'stretch'
                            },
                            items: [
                                {
                                    xtype: 'fieldset',
                                    flex: 3,
                                    margin: '0 8 0 0 ',
                                    checkboxName: 'check_fields',
                                    title: Ext.locale.translate('Checks'),
                                    items: [
                                        {
                                            xtype: 'combobox',
                                            anchor: '100%',
                                            fieldLabel: Ext.locale.translate('Period'),
                                            labelWidth: 110,
                                            name: 'check_period',
                                            value: '1',
                                            displayField: 'timeperiod_name',
                                            queryMode: 'local',
                                            store: 'timeperiod_store',
                                            valueField: 'timeperiod_id'
                                        },
                                        {
                                            xtype: 'numberfield',
                                            anchor: '100%',
                                            fieldLabel: Ext.locale.translate('Interval'),
                                            labelWidth: 110,
                                            name: 'normal_check_interval',
                                            value: 5
                                        },
                                        {
                                            xtype: 'numberfield',
                                            anchor: '100%',
                                            fieldLabel: Ext.locale.translate('Retry interval'),
                                            labelWidth: 110,
                                            name: 'retry_check_interval',
                                            value: 3
                                        },
                                        {
                                            xtype: 'numberfield',
                                            anchor: '100%',
                                            fieldLabel: Ext.locale.translate('Maximum Check Attempts'),
                                            labelWidth: 110,
                                            name: 'max_check_attempts',
                                            value: 3
                                        }
                                    ]
                                },
                                {
                                    xtype: 'fieldset',
                                    flex: 2,
                                    margin: '0 0 0 8',
                                    checkboxName: 'notification_fields',
                                    title: Ext.locale.translate('Notifications'),
                                    items: [
                                        {
                                            xtype: 'checkboxfield',
                                            anchor: '100%',
                                            fieldLabel: '',
                                            name: 'notifications_enabled',
                                            boxLabel: Ext.locale.translate('Notifications enabled'),
                                            checked: true
                                        },
                                        {
                                            xtype: 'combobox',
                                            anchor: '100%',
                                            fieldLabel: Ext.locale.translate('Period'),
                                            labelWidth: 60,
                                            name: 'notification_period',
                                            value: '1',
                                            displayField: 'timeperiod_name',
                                            queryMode: 'local',
                                            store: 'timeperiod_store',
                                            valueField: 'timeperiod_id'
                                        },
                                        {
                                            xtype: 'numberfield',
                                            anchor: '100%',
                                            fieldLabel: Ext.locale.translate('Interval'),
                                            labelWidth: 60,
                                            name: 'notification_interval',
                                            value: 0
                                        }
                                    ]
                                }
                            ]
                        },
                        {
                            xtype: 'fieldcontainer',
                            fieldLabel: '',
                            layout: {
                                type: 'hbox',
                                align: 'stretch'
                            },
                            items: [
                                {
                                    xtype: 'fieldset',
                                    flex: 1,
                                    margin: '0 8 0 0 ',
                                    title: Ext.locale.translate('Contactgroups and Contacts'),
                                    items: [
                                        {
                                            xtype: 'boxselect',
                                            anchor: '100%',
                                            itemId: 'contactGroup',
                                            fieldLabel: '',
                                            labelWidth: 130,
                                            name: 'contactGroups',
                                            emptyText: Ext.locale.translate('Select a contactgroup'),
                                            displayField: 'contactgroup_name',
                                            multiSelect: true,
                                            queryMode: 'local',
                                            store: 'contactgroups_store',
                                            valueField: 'contactgroup_id'
                                        },
                                        {
                                            xtype: 'boxselect',
                                            anchor: '100%',
                                            fieldLabel: '',
                                            labelWidth: 130,
                                            name: 'contacts',
                                            emptyText: Ext.locale.translate('Select a contacts'),
                                            displayField: 'contact_name',
                                            multiSelect: true,
                                            queryMode: 'local',
                                            store: 'contacts_store',
                                            valueField: 'contact_id'
                                        }
                                    ]
                                },
                                {
                                    xtype: 'fieldset',
                                    flex: 1,
                                    margin: '0 0 0 8',
                                    title: Ext.locale.translate('Servicegroup'),
                                    items: [
                                        {
                                            xtype: 'boxselect',
                                            anchor: '100%',
                                            fieldLabel: '',
                                            labelWidth: 130,
                                            name: 'serviceGroups',
                                            emptyText: Ext.locale.translate('Select a servicegroup'),
                                            displayField: 'servicegroup_name',
                                            multiSelect: true,
                                            queryMode: 'local',
                                            store: 'servicegroup_store',
                                            valueField: 'servicegroup_id'
                                        }
                                    ]
                                }
                            ]
                        }
                    ]
                }
            ]
        });

        me.callParent(arguments);
    },

    onAction_columnClick: function(actioncolumn, el, rowIndx, colIndx, dom, record) {
        var operation = model_wiz.helpers.Utils.choseAction(
            /.*ico-([^ ]+).*/,
            dom,
            {
                edit: actioncolumn.panel.resolveAction,
                remove: model_wiz.helpers.Utils.confirmAction(
                    Ext.locale.translate('Do you really want to not monitor this service?'),
                    actioncolumn.panel.removeAction,
                    this
                )
            },
            actioncolumn.panel
        );
        operation(record);
    },

    onCheckboxModelBeforeSelect: function(rowmodel, record, index, eOpts) {
        var result = Ext.getStore('license').selectData('services', record);
        return ! result.error;
    },

    onCheckboxModelBeforeDeselect: function(rowmodel, record, index, eOpts) {
        return Ext.getStore('license').deselectData('services', record);
    },

    onCheckboxModelDeselect: function(rowmodel, record, index, eOpts) {
        model_wiz.app.getController('steps.nav.Overview').updateLicenseCmp('hosts');
        model_wiz.app.getController('steps.nav.Overview').updateLicenseCmp('services');

        model_wiz.app.getController('steps.nav.Overview').updateAccordionHeader('hosts', Ext.getCmp('hosts_created').down());
        model_wiz.app.getController('steps.nav.Overview').updateAccordionHeader('hostsExisting', Ext.getCmp('hosts_modified').down());
        model_wiz.app.getController('steps.nav.Overview').updateAccordionHeader('services', Ext.getCmp('services_created').down());
        model_wiz.app.getController('steps.nav.Overview').updateAccordionHeader('servicesExisting', Ext.getCmp('services_conflict').down());
    },

    onCheckboxModelSelect: function(rowmodel, record, index, eOpts) {
        model_wiz.app.getController('steps.nav.Overview').updateLicenseCmp('hosts');
        model_wiz.app.getController('steps.nav.Overview').updateLicenseCmp('services');

        model_wiz.app.getController('steps.nav.Overview').updateAccordionHeader('hosts', Ext.getCmp('hosts_created').down());
        model_wiz.app.getController('steps.nav.Overview').updateAccordionHeader('hostsExisting', Ext.getCmp('hosts_modified').down());
        model_wiz.app.getController('steps.nav.Overview').updateAccordionHeader('services', Ext.getCmp('services_created').down());
        model_wiz.app.getController('steps.nav.Overview').updateAccordionHeader('servicesExisting', Ext.getCmp('services_conflict').down());
    },

    onCheckboxModelSelectionChange: function(model, selected, eOpts) {

    },

    onOverwrite_chkboxChange1: function(field, newValue, oldValue, eOpts) {
        Ext.ComponentQuery.query('#hosts_modified #settings_form fieldcontainer')
            .forEach(function(c) {
                c.setDisabled(! newValue);
            });
    }

});