/*
 * File: app/view/step_02.js
 *
 * This file was generated by Sencha Architect version 4.2.3.
 * http://www.sencha.com/products/architect/
 *
 * This file requires use of the Ext JS 4.2.x library, under independent license.
 * License of Sencha Architect does not include license for Ext JS 4.2.x. For more
 * details see http://www.sencha.com/license or contact license@sencha.com.
 *
 * This file will be auto-generated each and everytime you save your project.
 *
 * Do NOT hand edit this file.
 */

Ext.define('model_wiz.view.step_02', {
    extend: 'Ext.container.Container',
    alias: 'widget.step_02',

    requires: [
        'Ext.grid.Panel',
        'Ext.grid.column.Column',
        'Ext.form.field.Text',
        'Ext.view.Table',
        'Ext.toolbar.Toolbar',
        'Ext.button.Button',
        'Ext.selection.CheckboxModel'
    ],

    id: 'step_02',

    layout: {
        type: 'hbox',
        align: 'stretch'
    },

    initComponent: function() {
        var me = this;

        Ext.applyIf(me, {
            items: [
                {
                    xtype: 'gridpanel',
                    flex: 1,
                    id: 'host_list',
                    width: 1074,
                    header: false,
                    title: 'My Grid Panel',
                    columnLines: false,
                    emptyText: Ext.locale.translate('Any host has been found. Add a new one manually'),
                    forceFit: false,
                    store: 'hosts',
                    columns: [
                        {
                            xtype: 'gridcolumn',
                            renderer: function(value, metaData, record, rowIndex, colIndex, store, view) {
                                var x = record.get('class');
                                var states = {
                                    "1": Ext.locale.translate('Monitored'),
                                    "0": Ext.locale.translate('Not monitored'),
                                    "default": Ext.locale.translate('New host')
                                };
                                var description = states.hasOwnProperty(x) ? states[x] : states["default"];
                                metaData.tdAttr = 'data-qtip="'+ description +'"';

                                return '<div class="monitoring-state state-'+ (x !== "" ? x : "2") +'"></div>';
                            },
                            itemId: 'monitoringState',
                            width: 50,
                            dataIndex: 'class',
                            menuDisabled: true,
                            text: Ext.locale.translate('Monitoring state'),
                            tooltip: Ext.locale.translate('Monitoring state')
                        },
                        {
                            xtype: 'gridcolumn',
                            width: 120,
                            dataIndex: 'address',
                            text: Ext.locale.translate('Address'),
                            tooltip: Ext.locale.translate('Address'),
                            editor: {
                                xtype: 'textfield'
                            }
                        },
                        {
                            xtype: 'gridcolumn',
                            width: 300,
                            dataIndex: 'host_name',
                            text: Ext.locale.translate('Hostname'),
                            tooltip: Ext.locale.translate('Hostname')
                        },
                        {
                            xtype: 'gridcolumn',
                            dataIndex: 'alias',
                            text: Ext.locale.translate('Description'),
                            tooltip: Ext.locale.translate('Description'),
                            flex: 1
                        }
                    ],
                    viewConfig: {
                        xtype: 'tableview',
                        loadMask: false,
                        enableTextSelection: true
                    },
                    dockedItems: [
                        {
                            xtype: 'toolbar',
                            dock: 'top',
                            layout: {
                                type: 'hbox',
                                pack: 'end'
                            },
                            items: [
                                {
                                    xtype: 'textfield',
                                    id: 'search_ip',
                                    margin: '0 8 0 44',
                                    width: 139,
                                    fieldLabel: '',
                                    listeners: {
                                        change: {
                                            fn: me.onSearch_ipChange,
                                            scope: me
                                        }
                                    }
                                },
                                {
                                    xtype: 'textfield',
                                    id: 'search_hostname',
                                    width: 292,
                                    fieldLabel: '',
                                    listeners: {
                                        change: {
                                            fn: me.onSearch_hostnameChange,
                                            scope: me
                                        }
                                    }
                                },
                                {
                                    xtype: 'textfield',
                                    flex: 3,
                                    id: 'search_description',
                                    fieldLabel: '',
                                    listeners: {
                                        change: {
                                            fn: me.onSearch_descriptionChange,
                                            scope: me
                                        }
                                    }
                                }
                            ]
                        },
                        {
                            xtype: 'toolbar',
                            dock: 'bottom',
                            layout: {
                                type: 'hbox',
                                pack: 'center'
                            },
                            items: [
                                {
                                    xtype: 'button',
                                    handler: function(button, e) {
                                        Ext.create(model_wiz.view.modal.new_host, {
                                            renderTo: Ext.getBody()
                                        }).show();
                                    },
                                    iconCls: 'fa fa-plus icon-green',
                                    text: Ext.locale.translate('Add new host manually')
                                }
                            ]
                        }
                    ],
                    selModel: Ext.create('Ext.selection.CheckboxModel', {
                        checkOnly: true,
                        injectCheckbox: 'first',
                        showHeaderCheckbox: true
                    }),
                    listeners: {
                        selectionchange: {
                            fn: me.onHost_listSelectionChange,
                            scope: me
                        }
                    }
                }
            ]
        });

        me.callParent(arguments);
    },

    onSearch_ipChange: function(field, newValue, oldValue, eOpts) {
        var store = Ext.getStore('hosts');
        var regex = new RegExp(".*" + newValue + ".*");

        store.clearFilter(true);

        store.filter([{
        	property: "address",
        	value: regex
        }]);
    },

    onSearch_hostnameChange: function(field, newValue, oldValue, eOpts) {
        var store = Ext.getStore('hosts');
        var regex = new RegExp(".*" + newValue + ".*");

        store.clearFilter(true);

        store.filter([{
        	property: "host_name",
        	value: regex
        }]);
    },

    onSearch_descriptionChange: function(field, newValue, oldValue, eOpts) {
        var store = Ext.getStore('hosts');
        var regex = new RegExp(".*" + newValue + ".*");

        store.clearFilter(true);

        store.filter([{
        	property: "alias",
        	value: regex
        }]);
    },

    onHost_listSelectionChange: function(model, selected, eOpts) {
        model_wiz.app.getController('Navbar').triggerStep('host_select', [selected], 'enable_next');
    }

});